/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


#line 612 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    STATES = 372,
    FILTERS = 373,
    RECEIVE = 374,
    ACTION = 375,
    WARN = 376,
    BLOCK = 377,
    DISABLE = 378,
    KEEP = 379,
    FILTERED = 380,
    PASSWORD = 381,
    FROM = 382,
    PASSIVE = 383,
    TO = 384,
    EVENTS = 385,
    PACKETS = 386,
    PROTOCOLS = 387,
    INTERFACES = 388,
    PRIMARY = 389,
    STATS = 390,
    COUNT = 391,
    FOR = 392,
    COMMANDS = 393,
    PREEXPORT = 394,
    NOEXPORT = 395,
    GENERATE = 396,
    ROA = 397,
    LISTEN = 398,
    BGP = 399,
    V6ONLY = 400,
    DUAL = 401,
    ADDRESS = 402,
    PASSWORDS = 403,
    DESCRIPTION = 404,
    SORTED = 405,
    RELOAD = 406,
    IN = 407,
    OUT = 408,
    MRTDUMP = 409,
    MESSAGES = 410,
    RESTRICT = 411,
    MEMORY = 412,
    IGP_METRIC = 413,
    CLASS = 414,
    DSCP = 415,
    WAIT = 416,
    MAX = 417,
    FLUSH = 418,
    AS = 419,
    SHOW = 420,
    STATUS = 421,
    SUMMARY = 422,
    ROUTE = 423,
    SYMBOLS = 424,
    ADD = 425,
    DELETE = 426,
    DUMP = 427,
    RESOURCES = 428,
    SOCKETS = 429,
    NEIGHBORS = 430,
    ATTRIBUTES = 431,
    EVAL = 432,
    ECHO = 433,
    ENABLE = 434,
    FUNCTION = 435,
    PRINT = 436,
    PRINTN = 437,
    UNSET = 438,
    RETURN = 439,
    ACCEPT = 440,
    REJECT = 441,
    QUITBIRD = 442,
    INT = 443,
    BOOL = 444,
    IP = 445,
    PREFIX = 446,
    PAIR = 447,
    QUAD = 448,
    EC = 449,
    SET = 450,
    STRING = 451,
    BGPMASK = 452,
    BGPPATH = 453,
    CLIST = 454,
    ECLIST = 455,
    IF = 456,
    THEN = 457,
    ELSE = 458,
    CASE = 459,
    TRUE = 460,
    FALSE = 461,
    RT = 462,
    RO = 463,
    UNKNOWN = 464,
    GENERIC = 465,
    GW = 466,
    NET = 467,
    MASK = 468,
    PROTO = 469,
    SOURCE = 470,
    SCOPE = 471,
    CAST = 472,
    DEST = 473,
    IFNAME = 474,
    IFINDEX = 475,
    LEN = 476,
    DEFINED = 477,
    CONTAINS = 478,
    RESET = 479,
    PREPEND = 480,
    FIRST = 481,
    LAST = 482,
    LAST_NONAGGREGATED = 483,
    MATCH = 484,
    ROA_CHECK = 485,
    EMPTY = 486,
    WHERE = 487,
    BFD = 488,
    MIN = 489,
    IDLE = 490,
    RX = 491,
    TX = 492,
    INTERVAL = 493,
    MULTIPLIER = 494,
    MULTIHOP = 495,
    NEIGHBOR = 496,
    DEV = 497,
    LOCAL = 498,
    SESSIONS = 499,
    HOLD = 500,
    CONNECT = 501,
    RETRY = 502,
    KEEPALIVE = 503,
    STARTUP = 504,
    VIA = 505,
    NEXT = 506,
    HOP = 507,
    SELF = 508,
    DEFAULT = 509,
    PATH = 510,
    START = 511,
    DELAY = 512,
    FORGET = 513,
    AFTER = 514,
    BGP_PATH = 515,
    BGP_LOCAL_PREF = 516,
    BGP_MED = 517,
    BGP_ORIGIN = 518,
    BGP_NEXT_HOP = 519,
    BGP_ATOMIC_AGGR = 520,
    BGP_AGGREGATOR = 521,
    BGP_COMMUNITY = 522,
    BGP_EXT_COMMUNITY = 523,
    RR = 524,
    RS = 525,
    CLIENT = 526,
    CLUSTER = 527,
    AS4 = 528,
    ADVERTISE = 529,
    IPV4 = 530,
    CAPABILITIES = 531,
    PREFER = 532,
    OLDER = 533,
    MISSING = 534,
    LLADDR = 535,
    DROP = 536,
    IGNORE = 537,
    REFRESH = 538,
    INTERPRET = 539,
    COMMUNITIES = 540,
    BGP_ORIGINATOR_ID = 541,
    BGP_CLUSTER_LIST = 542,
    IGP = 543,
    GATEWAY = 544,
    RECURSIVE = 545,
    MED = 546,
    TTL = 547,
    SECURITY = 548,
    DETERMINISTIC = 549,
    SECONDARY = 550,
    ALLOW = 551,
    AWARE = 552,
    LINK = 553,
    EXTENDED = 554,
    SETKEY = 555,
    OSPF = 556,
    AREA = 557,
    OSPF_METRIC1 = 558,
    OSPF_METRIC2 = 559,
    OSPF_TAG = 560,
    OSPF_ROUTER_ID = 561,
    RFC1583COMPAT = 562,
    STUB = 563,
    TICK = 564,
    COST = 565,
    COST2 = 566,
    RETRANSMIT = 567,
    HELLO = 568,
    TRANSMIT = 569,
    PRIORITY = 570,
    DEAD = 571,
    TYPE = 572,
    BROADCAST = 573,
    BCAST = 574,
    NONBROADCAST = 575,
    NBMA = 576,
    POINTOPOINT = 577,
    PTP = 578,
    POINTOMULTIPOINT = 579,
    PTMP = 580,
    SIMPLE = 581,
    AUTHENTICATION = 582,
    STRICT = 583,
    CRYPTOGRAPHIC = 584,
    ELIGIBLE = 585,
    POLL = 586,
    NETWORKS = 587,
    HIDDEN = 588,
    VIRTUAL = 589,
    ONLY = 590,
    BUFFER = 591,
    LARGE = 592,
    NORMAL = 593,
    STUBNET = 594,
    TAG = 595,
    EXTERNAL = 596,
    LSADB = 597,
    ECMP = 598,
    WEIGHT = 599,
    NSSA = 600,
    TRANSLATOR = 601,
    STABILITY = 602,
    GLOBAL = 603,
    LSID = 604,
    INSTANCE = 605,
    REAL = 606,
    NETMASK = 607,
    LENGTH = 608,
    LSA = 609,
    SUPPRESSION = 610,
    TOPOLOGY = 611,
    STATE = 612,
    PIPE = 613,
    PEER = 614,
    MODE = 615,
    OPAQUE = 616,
    TRANSPARENT = 617,
    RIP = 618,
    INFINITY = 619,
    UPDATE = 620,
    GARBAGE = 621,
    MULTICAST = 622,
    VERSION = 623,
    SPLIT = 624,
    HORIZON = 625,
    POISON = 626,
    REVERSE = 627,
    ZERO = 628,
    PLAINTEXT = 629,
    MD5 = 630,
    RIP_METRIC = 631,
    RIP_TAG = 632,
    STATIC = 633,
    PROHIBIT = 634,
    MULTIPATH = 635,
    BLACKHOLE = 636,
    UNREACHABLE = 637
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 541 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1062 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1079 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  70
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3168

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  404
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  267
/* YYNRULES -- Number of rules.  */
#define YYNRULES  912
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1713

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   637

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     395,   396,    29,    27,   400,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   397,   394,
      23,    22,    24,   401,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   402,     2,   403,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   398,     2,   399,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   733,   733,   734,   737,   739,   747,   756,   757,   758,
     765,   766,   767,   775,   776,   777,   778,   779,   780,   786,
     787,   794,   795,   799,   806,   807,   811,   815,   822,   830,
     831,   838,   839,   845,   854,   855,   859,   864,   865,   869,
     870,   874,   875,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   893,   894,   904,   905,   906,   907,   910,   911,
     912,   913,   914,   915,   919,   925,   926,   927,   928,   936,
     939,   946,   949,   952,   955,   959,   960,   964,   965,   966,
     974,   979,   980,   984,   985,   989,   996,   997,   998,  1010,
    1015,  1019,  1033,  1034,  1048,  1049,  1053,  1054,  1055,  1056,
    1063,  1077,  1079,  1081,  1085,  1086,  1087,  1088,  1093,  1099,
    1100,  1104,  1112,  1116,  1118,  1124,  1125,  1132,  1133,  1137,
    1143,  1147,  1156,  1165,  1167,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1186,  1187,  1188,
    1189,  1193,  1194,  1195,  1196,  1197,  1201,  1207,  1211,  1219,
    1220,  1228,  1236,  1237,  1238,  1242,  1243,  1247,  1252,  1253,
    1257,  1259,  1267,  1271,  1272,  1278,  1285,  1286,  1287,  1288,
    1292,  1300,  1306,  1307,  1308,  1312,  1313,  1317,  1318,  1319,
    1320,  1321,  1322,  1328,  1329,  1330,  1334,  1335,  1339,  1340,
    1346,  1347,  1350,  1352,  1356,  1357,  1361,  1379,  1380,  1381,
    1382,  1383,  1384,  1392,  1395,  1398,  1401,  1405,  1406,  1409,
    1412,  1416,  1420,  1425,  1431,  1438,  1443,  1448,  1453,  1457,
    1461,  1465,  1474,  1482,  1486,  1493,  1494,  1495,  1500,  1504,
    1511,  1518,  1522,  1530,  1531,  1532,  1537,  1541,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1555,  1560,  1568,  1575,  1582,
    1590,  1592,  1594,  1596,  1598,  1600,  1602,  1604,  1607,  1611,
    1617,  1618,  1619,  1623,  1624,  1630,  1632,  1634,  1636,  1638,
    1640,  1644,  1648,  1651,  1655,  1656,  1657,  1661,  1662,  1663,
    1671,  1671,  1681,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1718,  1729,  1730,  1737,
    1738,  1745,  1754,  1758,  1762,  1786,  1787,  1791,  1804,  1804,
    1820,  1821,  1824,  1825,  1829,  1832,  1841,  1854,  1855,  1856,
    1857,  1858,  1862,  1870,  1871,  1872,  1873,  1874,  1878,  1881,
    1882,  1883,  1887,  1890,  1899,  1902,  1903,  1904,  1905,  1909,
    1910,  1911,  1915,  1916,  1917,  1918,  1922,  1923,  1924,  1925,
    1929,  1930,  1934,  1935,  1939,  1946,  1947,  1948,  1949,  1956,
    1957,  1960,  1961,  1968,  1980,  1981,  1985,  1986,  1990,  1991,
    1992,  1993,  1994,  1995,  1999,  2000,  2001,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2019,  2020,
    2030,  2034,  2057,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2084,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,
    2102,  2103,  2104,  2106,  2108,  2110,  2112,  2113,  2114,  2115,
    2116,  2117,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2135,
    2136,  2141,  2164,  2165,  2166,  2167,  2168,  2169,  2173,  2176,
    2177,  2178,  2186,  2193,  2202,  2203,  2207,  2213,  2223,  2232,
    2238,  2243,  2250,  2255,  2261,  2262,  2263,  2271,  2272,  2273,
    2274,  2275,  2281,  2293,  2294,  2295,  2296,  2299,  2301,  2305,
    2309,  2320,  2321,  2322,  2323,  2324,  2325,  2328,  2330,  2333,
    2335,  2338,  2341,  2346,  2347,  2348,  2352,  2353,  2357,  2358,
    2361,  2380,  2386,  2411,  2413,  2414,  2418,  2419,  2420,  2421,
    2422,  2423,  2429,  2430,  2431,  2432,  2433,  2434,  2435,  2436,
    2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,
    2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,
    2467,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,
    2482,  2483,  2484,  2485,  2486,  2487,  2498,  2508,  2509,  2513,
    2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2524,  2539,
    2542,  2544,  2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,
    2556,  2557,  2557,  2558,  2558,  2559,  2560,  2561,  2565,  2566,
    2570,  2578,  2580,  2584,  2585,  2586,  2590,  2591,  2594,  2596,
    2599,  2600,  2601,  2602,  2603,  2604,  2605,  2606,  2607,  2608,
    2609,  2612,  2632,  2633,  2634,  2635,  2636,  2637,  2638,  2639,
    2640,  2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,
    2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,
    2670,  2673,  2675,  2678,  2680,  2689,  2691,  2692,  2695,  2697,
    2701,  2702,  2705,  2715,  2736,  2738,  2742,  2742,  2745,  2747,
    2750,  2752,  2756,  2760,  2761,  2766,  2769,  2772,  2777,  2780,
    2785,  2788,  2792,  2796,  2799,  2800,  2801,  2802,  2803,  2804,
    2805,  2806,  2812,  2819,  2820,  2821,  2826,  2827,  2833,  2846,
    2847,  2848,  2849,  2850,  2853,  2855,  2859,  2863,  2886,  2902,
    2903,  2904,  2905,  2906,  2907,  2908,  2912,  2913,  2914,  2915,
    2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,
    2926,  2927,  2928,  2929,  2933,  2934,  2935,  2936,  2939,  2941,
    2944,  2946,  2950,  2956,  2959,  2966,  2973,  2974,  2975,  2976,
    2977,  2980,  2990,  2999,  3003,  3009,  3010,  3014,  3019,  3025,
    3028,  3033,  3034,  3035,  3036,  3037,  3041,  3042,  3045,  3047,
    3050,  3052,  3056,  3063,  3063,  3063,  3063,  3063,  3063,  3063,
    3063,  3063,  3063,  3063,  3063,  3063,  3063,  3063,  3063,  3064,
    3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,
    3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,
    3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,
    3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,
    3064,  3064,  3064,  3064,  3064,  3064,  3064,  3064,  3065,  3065,
    3065,  3065,  3065,  3065,  3065,  3065,  3065,  3066,  3066,  3066,
    3066,  3067,  3067,  3067,  3068,  3068,  3068,  3068,  3068,  3068,
    3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,
    3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,  3068,
    3068,  3068,  3068,  3068,  3068,  3069,  3069,  3070,  3071,  3072,
    3073,  3074,  3075,  3076,  3077,  3078,  3079,  3080,  3080,  3080,
    3080,  3080,  3080
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY",
  "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW", "STATUS",
  "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO", "ENABLE",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "IF", "THEN", "ELSE",
  "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET",
  "MASK", "PROTO", "SOURCE", "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX",
  "LEN", "DEFINED", "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST",
  "LAST_NONAGGREGATED", "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "BFD",
  "MIN", "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP",
  "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "START", "DELAY", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC",
  "SECONDARY", "ALLOW", "AWARE", "LINK", "EXTENDED", "SETKEY", "OSPF",
  "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "LENGTH", "LSA", "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE",
  "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "UPDATE",
  "GARBAGE", "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON",
  "REVERSE", "ZERO", "PLAINTEXT", "MD5", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'", "'('", "')'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "debug_unix", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_item",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,    59,    40,    41,    58,   123,   125,
      44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1374

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1374)))

#define YYTABLE_NINF -455

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-455)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      34,  2903,    53,   634,   863,   699,    68,   863,   863,   899,
     863,   166,   -67,  2136,    54,   116,   889,  1609,   115,   863,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   168,   375,   506,   644,   298,   211,   326,   246,
   -1374, -1374,   362,   329,   268,   278,  1609,   420, -1374, -1374,
   -1374, -1374, -1374, -1374,    78,    78, -1374, -1374, -1374, -1374,
     117, -1374,   612, -1374,    78,  2615, -1374, -1374, -1374,    78,
   -1374,    78,  2569,    78,  2591,    78,  2593,    78, -1374,    78,
    1335, -1374, -1374,  2387,  2769, -1374, -1374, -1374,   188, -1374,
     460,   533,   553,   460,   386, -1374,   581,   610,   863,   863,
     624,   202, -1374,   523,   963,    93, -1374,   640,   655, -1374,
   -1374,   392,   536,   -20,   652,   647,   647,   678,   683,   694,
     696,   702,   705,   708,   714,    39, -1374, -1374, -1374,   698,
     331, -1374,   495,    59,    -1,  1609, -1374,   344,   348,   371,
   -1374, -1374,   374,   376,   388,  1025,   196, -1374, -1374, -1374,
   -1374, -1374,  2257, -1374,  2379, -1374, -1374,  1597,   770,   778,
     776, -1374, -1374,   738, -1374, -1374,   -25,   274,   188,   275,
   -1374, -1374, -1374, -1374,   309,   409,   275,   275,   637,   651,
     224, -1374,   798, -1374,   202,   430,  2248, -1374,   693,   814,
     438,   441, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   466,   188,   549,   848,   781,   275,   323, -1374,
     575,   311,   832,   673,   202, -1374,   515,   526,   537,   540,
     102,   660,   880,   570,   946,   701,   673,   323,   906,   892,
     419,   840,   323,   140,   647,   498,   944,   252,   949,   783,
     768,   542,   947,   769,   538,   772,   773,   323,   788,   774,
     762,   766,    27,   985,   792,   780,   323,   826,   323, -1374,
     704,   712,   740,   173,   323,   984,   275,   323,   996, -1374,
   -1374,   728,   727, -1374,   737,  1040,   499, -1374,   733,   739,
     741,   831,   647,  1047, -1374,   748,   726,   745,  1060,   323,
    1076,   323,  1074,  1075,  1072,   275, -1374,   764,   765,   779,
    1085,  1142, -1374,   782,   784, -1374, -1374,   811,  1161,   386,
   -1374, -1374,  1169,   275,  1171, -1374, -1374,  1172,  1176, -1374,
   -1374, -1374,   -13,  1187,  1174,  1193, -1374, -1374,   866,  1197,
   -1374,  1198,   509, -1374, -1374,  2883,  1296,   652, -1374,   652,
     652, -1374,   294,   488,  1199,   652,   652,  1200, -1374, -1374,
      29,  1031,  1032, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,    17, -1374,    39,  1609,    39,    39,  1194, -1374,  1195,
    1051,  1182,   969,  1184,    -1,    -1,  1188,  1190,  1609,  1609,
    1609,  1609,  1609,  1201, -1374, -1374,  1210, -1374,   829,    55,
   -1374, -1374, -1374, -1374,   729, -1374,  1219, -1374, -1374, -1374,
     -24,    67, -1374,    82, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374,  1609,  1609,  1609,  1609,
    1609,  1609,  1609,  1609,  1609,  1609,  1609,  1609,  1609,  1609,
     735, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
     507, -1374, -1374,  1228, -1374,  1609,   673, -1374, -1374,  1597,
     841, -1374, -1374, -1374, -1374, -1374, -1374,   275,  1609, -1374,
   -1374, -1374, -1374,   275,   919,   924, -1374,   902, -1374, -1374,
     275, -1374, -1374, -1374, -1374, -1374, -1374, -1374,  1609,   844,
    2359, -1374,   330,   845, -1374,   839,  1221, -1374, -1374, -1374,
    -108, -1374, -1374,   323, -1374, -1374,   173, -1374, -1374, -1374,
   -1374,   216,  1516, -1374,  1112,  1609, -1374, -1374,   216, -1374,
     216, -1374, -1374, -1374, -1374, -1374, -1374,  1173,  1177,   323,
     127, -1374,   856,  1203,   861,   862,   275,   137,   965,   323,
    1091,   647,   871, -1374,   875,  1229,    75,   275,  1102,   275,
    1202,  1204,   275,  1205,    -3,   275,   275,   323,  1206,   885,
    1166,   895,   323,   897,   323,   518,   323,   848,   323,   900,
     901,   323,   323,   323,   903,  1111,   907, -1374, -1374,   323,
   -1374, -1374,   323, -1374,  1234,   275, -1374, -1374, -1374,  1279,
     911,   918, -1374, -1374, -1374,   323, -1374,   848, -1374, -1374,
     976, -1374,   647, -1374,  1052, -1374, -1374, -1374,   920,   275,
   -1374,   275, -1374,   323,   323,   323, -1374, -1374, -1374, -1374,
     275, -1374,   647, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,   589, -1374, -1374,  1313, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   592, -1374, -1374, -1374, -1374,  1314, -1374, -1374,
   -1374,  1303, -1374, -1374,  1310,   647, -1374, -1374,  1307,  1312,
   -1374,  1516, -1374, -1374, -1374, -1374,   647, -1374, -1374, -1374,
    1315, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
    1326,  1318,  1318,   835,   652,  1318,   652,  1318, -1374,  1318,
    1318, -1374,   275,   647, -1374,  1317,  1320,  1342, -1374, -1374,
     818, -1374, -1374, -1374, -1374,    81, -1374,   937, -1374,  1331,
   -1374, -1374, -1374, -1374,   111,   171,   254,   851,   434,   180,
   -1374,  1609, -1374,  1609, -1374,  1353,   961,   962,   904,   373,
     455, -1374, -1374, -1374,  1360,  1362, -1374,  2643,  2643,  2643,
    2913,  2913,  2643,  2643,  2643,  2643,  2643,   775,   775,  1190,
    1190, -1374,   983, -1374, -1374, -1374, -1374, -1374,  1597, -1374,
    2074, -1374,   604, -1374, -1374,  1079,  1363, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374,   993, -1374,   995,  1158, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,   191,   998,   992, -1374, -1374,   275, -1374, -1374,   647,
   -1374, -1374, -1374,  1337,  2359, -1374,   647, -1374,  1005, -1374,
    1374, -1374,  1003, -1374,  1273, -1374, -1374, -1374, -1374,   323,
    2248, -1374, -1374,  2177,   275,   275,  1013,   275,  1015,  1018,
   -1374,   323, -1374, -1374,  1022,  1024,  1029,  1030,   323,  1034,
     323,  1035, -1374, -1374,  1394, -1374,   275,   275, -1374,  1036,
     275,  1039,   275,   275,  1041,   275,  1049,  1054,  1058,  1064,
    1067,   275, -1374,   173, -1374,  1068, -1374,  1069,  1070,  1073,
    1077,  1080,  1086,  1087, -1374, -1374,  1088,  1089,  1090, -1374,
     187, -1374, -1374, -1374,   275, -1374,   657,  1099, -1374, -1374,
    2329,  1103,  1105, -1374,  1229, -1374,   647,   113,  1052,   138,
   -1374, -1374, -1374, -1374, -1374,  1350, -1374,    29, -1374, -1374,
   -1374,   811, -1374, -1374,   -13, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374,  1422,  1431, -1374, -1374,
     173, -1374, -1374,   173,  1439, -1374,   173,  1318,  1463,  1318,
    1467,  1482,  1499, -1374, -1374,  1330,  1334,    39, -1374,  1609,
   -1374,  1478,  1609,  1609,  1609, -1374,  1609, -1374,  1609,   517,
    1343,  1609,  1291,  1609, -1374, -1374,  1609, -1374, -1374,  1110,
     698, -1374,  1609, -1374, -1374, -1374, -1374, -1374, -1374,  1003,
   -1374, -1374, -1374, -1374,  2359,  1078, -1374, -1374, -1374,  1121,
    1120, -1374,  1344, -1374, -1374,  1004, -1374,   824, -1374, -1374,
   -1374, -1374,   647, -1374, -1374,  1129,  1125,  1132, -1374,  1134,
   -1374, -1374,  1135, -1374, -1374, -1374, -1374,  1136, -1374,  1140,
   -1374, -1374,   125, -1374, -1374, -1374,  1149, -1374,  1156,  1159,
   -1374,  1162, -1374, -1374, -1374, -1374, -1374,  1167,  1168, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,  1175, -1374, -1374,   323,   414,   280, -1374,  1243,   647,
   -1374, -1374,   190, -1374,  1191, -1374,  1207, -1374, -1374,   323,
     275, -1374, -1374,  1192, -1374, -1374, -1374,  1229,   323,   275,
     113,    30, -1374,  1541, -1374, -1374,  1186,  1609, -1374, -1374,
   -1374,  1609,  1609,   323, -1374,  2257,  1196,  1378, -1374, -1374,
     275, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
    1563, -1374,  1564, -1374, -1374, -1374,  1567,  1572, -1374, -1374,
   -1374,  1647,  1732,  1773,  1808,   606,  1609, -1374, -1374,  2248,
    1213,  1189,  2248,   904,  1573,  1843, -1374,  1211,    25, -1374,
    2359, -1374,  1576,   647, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374,  1214, -1374,    87, -1374, -1374,   275, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374,   275,   275,   323,   275, -1374,
    1223,   173, -1374, -1374,  1225,  1232,   275, -1374, -1374,   275,
    1233, -1374, -1374,  1523, -1374, -1374, -1374, -1374, -1374,  1609,
    1051,  1609, -1374,  2107,  2413,   767,  1208,  1575,   516, -1374,
    2248,  1235,  1239, -1374, -1374, -1374,   523,   523, -1374, -1374,
   -1374, -1374,  1609,  1869,  1592,  1588,  1241, -1374, -1374, -1374,
   -1374,  1477, -1374,  1003,  1214, -1374, -1374,  1619,   673,  1399,
    1260,  1003,  1262, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374,  1264,   275,  2133,  1267,  2162,  2495,
   -1374,  1381, -1374, -1374,  1609,  1609,   879,  1378, -1374,  1661,
    1663,  1895, -1374,  1272,  1282,    11, -1374,  1664, -1374,   433,
   -1374, -1374,   647,  1432, -1374,  1207, -1374, -1374,    15,   301,
      37,  1165, -1374, -1374, -1374, -1374, -1374, -1374,  1288,  1078,
    1471, -1374,    33,  2188,  2218,  1292,  1293,  1294,  1295,  1297,
   -1374, -1374, -1374, -1374,  1609, -1374,  1609, -1374,  1300,   323,
     763,  1447,   275,   275, -1374,  1302, -1374,   323, -1374, -1374,
    2733, -1374, -1374, -1374,   209,   323,   275,   323, -1374,  1304,
   -1374,   673,  1299,   275,   275,   275,  1433,   128,   -14, -1374,
   -1374, -1374,  1301,  1306,  2166, -1374,  1308,  1305,  1381,   110,
   -1374, -1374, -1374,   729, -1374, -1374,  1700, -1374, -1374, -1374,
     256, -1374, -1374,  1609,  1609,  1609,  1609, -1374,  1309,  1316,
   -1374, -1374,  1461,  1462,  1464, -1374, -1374, -1374, -1374,  1413,
     275,  1332,   323,  1384,   387,  1424,   323,  1371,   323,   275,
     275,   275,  1469,   275,   217,  1014,  1375,     4,  1414,   275,
    1391,  1418, -1374, -1374,  1354, -1374,   275,  1355, -1374, -1374,
   -1374, -1374, -1374,  1613, -1374, -1374, -1374,   275,   275, -1374,
   -1374, -1374, -1374,   450, -1374,   275,    12,  1675,   275,   323,
     647,   323,  1405,   493,  1449,   222,  1408,    -9,  1688,  1690,
     253,  1386,  1385, -1374, -1374,  1377, -1374, -1374, -1374, -1374,
    1921,    57,   110,    83,  1947,  1990,  2022,  2048,  1609, -1374,
     275,   275,   275,   323, -1374, -1374, -1374,   135,   275,   275,
     275,   275, -1374,   412, -1374,  1409, -1374, -1374, -1374, -1374,
     275, -1374,   275, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   323, -1374, -1374, -1374,   323, -1374,   275,   323,
   -1374, -1374, -1374,  1379,  1380, -1374, -1374,   275,   454,   483,
    1387, -1374,   323,   323,   275, -1374, -1374, -1374, -1374,   275,
     275,   275, -1374,   568, -1374, -1374, -1374, -1374, -1374,   275,
   -1374, -1374,   275,   275,   323, -1374,   323,   323, -1374, -1374,
    1609, -1374, -1374, -1374,  1382,  1383,  1393,  1395,  1392, -1374,
   -1374, -1374, -1374,    42, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,  1446, -1374,   323, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,  1613,  1400,  1787,  1787,  1787,  1787, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374,  1465, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,  1921, -1374, -1374, -1374, -1374, -1374, -1374,  1452,
   -1374, -1374, -1374, -1374,   450, -1374,  1415,  1416,  1419,  1420,
   -1374, -1374,  1421, -1374,   450,   450,   450,   450, -1374, -1374,
   -1374, -1374, -1374
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   390,     0,     0,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,     3,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     117,   118,     0,     0,     0,     0,   390,     0,   783,   784,
     785,   786,   787,   788,   119,   119,   789,   790,   791,   792,
     115,   793,     0,   795,   119,   123,   796,   797,   798,   119,
     851,   119,   123,   119,   123,   119,   123,   119,   855,   119,
     123,     5,   794,   123,   123,   274,   276,   275,     0,    76,
      75,     0,     0,    75,    77,    74,     0,     0,     0,     0,
       0,     0,   273,   245,   278,     0,   229,     0,     0,   212,
     237,     0,   208,     0,   208,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   373,   377,   386,   383,   316,
     392,   380,     0,     0,   376,   390,   423,     0,     0,     0,
     378,   379,     0,     0,     0,   390,     0,   381,   382,   387,
     421,   422,     0,   420,     0,   261,   260,     0,   263,     0,
       0,    30,    29,    35,    38,    36,     0,    18,     0,     0,
      57,    56,    55,    54,     0,     0,     0,     0,     0,   109,
       0,   280,     0,   102,     0,     0,   282,   308,   120,     0,
       0,     0,   113,    80,    89,   165,   502,   472,   566,   702,
     708,   755,     0,     0,     0,     0,     0,     0,    18,   170,
       0,     0,     0,     0,     0,   850,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,   503,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,    18,   852,
       0,     0,     0,     0,    18,     0,     0,    18,     0,   853,
     569,     0,     0,   577,     0,     0,     0,   854,     0,     0,
       0,     0,     0,     0,   856,     0,     0,   780,     0,    18,
       0,    18,     0,     0,     0,     0,   848,     0,     0,     0,
       0,    32,   849,     0,     0,   173,   172,     0,     0,    77,
      71,    72,     0,    78,     0,   267,   265,     0,     0,   268,
     184,   183,     0,     0,     0,     0,   277,   279,   278,     0,
     209,     0,   233,   204,   203,     0,     0,   208,   207,   208,
     208,   693,   208,   208,     0,   208,   208,     0,    19,    20,
       0,     0,     0,   256,   252,   257,   253,   250,   251,   254,
     255,   373,   392,   373,   390,   373,   373,     0,   364,     0,
     390,     0,     0,     0,   376,   376,     0,   418,   390,   390,
     390,   390,   390,     0,   335,   336,     0,   338,     0,     0,
     317,   320,   318,   322,   390,   319,   344,   342,   343,   350,
       0,   355,   359,     0,   895,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   393,   894,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   897,   900,   899,   896,
     898,   901,   902,   903,   906,   904,   905,   907,   908,   909,
     910,   911,   912,   424,   425,   258,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
       0,    43,    44,    45,    46,    47,    48,    49,    50,    51,
       0,    41,   264,     0,   266,   390,     0,    37,    39,     0,
       0,     7,     9,    14,    16,    15,    17,     0,   390,    13,
      65,   149,   150,    58,     0,     0,    64,     0,    67,    68,
       0,   110,   111,    96,    98,    99,   100,   161,   390,     0,
     297,   112,     0,     0,    53,     0,     0,   121,   857,   861,
       0,   166,   126,    18,   148,   134,     0,   124,   125,   151,
     139,     0,   297,   140,     0,   390,   128,   138,     0,   129,
       0,   136,   127,   167,   168,   477,   506,     0,     0,    18,
      18,   518,     0,     0,     0,     0,     0,    18,     0,    18,
       0,     0,     0,   519,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,    18,     0,    18,     0,    18,     0,
       0,    18,    18,    18,     0,     0,     0,   507,   567,    18,
     578,   570,    18,   575,   572,     0,   568,   580,   703,     0,
       0,     0,   704,   714,   756,    18,   761,     0,   757,   772,
       0,   771,     0,   775,     0,   773,   774,   778,     0,     0,
      83,     0,    85,    18,    18,    18,    93,   859,   860,   858,
       0,    31,     0,   863,   862,   178,   177,   179,   181,   182,
     180,     0,   175,   271,     0,    73,    79,    69,   269,   270,
     188,   189,     0,   186,   272,   246,   249,     0,   205,   210,
     228,     0,   235,   234,     0,     0,   211,   218,     0,     0,
     226,   297,   220,   219,   223,   224,     0,   225,   227,   213,
       0,   217,   236,   244,   238,   241,   242,   240,   243,   239,
       0,   684,   684,     0,   208,   684,   208,   684,   685,   684,
     684,   782,     0,     0,    23,     0,     0,     0,   368,   370,
       0,   371,   372,   366,   354,   452,   455,     0,   432,     0,
     433,   374,   375,   367,     0,     0,     0,     0,     0,     0,
     337,   390,   403,   390,   331,   329,     0,     0,   328,     0,
       0,   384,   356,   357,     0,     0,   385,   415,   413,   411,
     408,   409,   410,   412,   414,   416,   417,   404,   405,   406,
     407,   426,     0,   427,   429,   430,   431,   262,     0,   259,
       0,    34,     0,    33,    66,     0,     0,    60,    61,    62,
      63,    10,    11,    12,     0,   151,     0,     0,    94,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,     0,     0,     0,   281,   301,     0,   106,   107,     0,
     101,   103,    52,     0,   297,   122,     0,   116,     0,   135,
     155,   158,   171,   147,   141,   131,   302,   303,   137,    18,
     304,   132,   130,   123,     0,     0,     0,     0,     0,     0,
     512,    18,   548,   551,     0,     0,     0,     0,    18,     0,
      18,     0,   565,   520,     0,   503,     0,     0,   510,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   514,     0,   515,     0,   546,     0,     0,     0,
       0,     0,     0,     0,   526,   527,     0,     0,     0,   553,
       0,   549,   574,   571,     0,   576,     0,     0,   706,   707,
     123,     0,     0,   768,    21,   770,     0,   765,   769,   390,
     760,    92,    84,    86,    87,    81,    90,    25,    24,    91,
     174,     0,    70,   185,     0,   206,   232,   231,   230,   215,
     222,   216,   214,   221,   501,   683,     0,     0,   692,   701,
       0,   699,   696,     0,     0,   694,     0,   684,     0,   684,
       0,     0,     0,    26,    27,     0,     0,   373,   365,   390,
     441,     0,   390,   390,   390,   419,   390,   439,   390,     0,
       0,   390,   390,   390,   321,   316,   390,   345,   351,     0,
       0,   360,   390,    42,     6,    40,     8,    59,   108,   162,
      95,    97,   296,   295,   297,   390,   105,   104,   306,   299,
       0,   309,     0,   169,   156,     0,   151,     0,   146,   133,
     480,   480,     0,   479,   473,     0,     0,     0,   564,     0,
     560,   559,     0,   550,   554,   555,   556,     0,   544,     0,
     535,    22,     0,   504,   505,   508,     0,   516,     0,     0,
     539,     0,   522,   521,   534,   533,   528,     0,     0,   547,
     531,   523,   524,   525,   552,   562,   530,   529,   563,   532,
     557,     0,   573,   673,    18,     0,    18,   591,     0,     0,
     593,   583,    18,   579,     0,   597,   674,   705,   717,    18,
       0,   716,   709,     0,   758,   759,   767,    21,    18,     0,
     766,     0,   445,     0,   446,   447,     0,   390,   443,   444,
     442,   390,   390,    18,   781,     0,     0,   390,   776,   779,
       0,    88,   176,   187,   687,   686,   700,   695,   697,   698,
       0,   688,     0,   690,   753,   754,     0,     0,   369,   453,
     434,     0,     0,     0,     0,     0,   390,   388,   330,   328,
       0,     0,   334,     0,     0,     0,   298,     0,   390,   312,
       0,   305,     0,   152,   153,   157,   159,   144,   142,   143,
     145,   151,   474,   489,   475,   493,   476,   478,     0,   540,
     561,   542,   543,   545,   511,   509,   538,   537,   517,   536,
     513,   558,   151,   596,   584,     0,     0,    18,     0,   582,
       0,     0,   600,   595,   599,     0,     0,   589,   581,     0,
     607,   151,   713,   710,   712,   715,   762,   764,   763,   390,
     390,   390,   390,     0,     0,     0,     0,     0,     0,   465,
     448,   450,     0,    82,   689,   691,   245,   245,   438,   436,
     437,   435,   390,     0,   332,   390,     0,   428,   307,   313,
     300,     0,   154,   160,   489,   487,   492,     0,     0,   496,
       0,   676,   680,   586,   587,   585,   588,   661,   621,   601,
     661,   590,   675,   608,   750,     0,     0,     0,     0,     0,
     459,   390,   361,   777,   390,   390,     0,   390,   464,     0,
       0,     0,   389,     0,     0,     0,   358,     0,   491,     0,
     494,   495,     0,   498,   541,   674,   678,   682,     0,     0,
       0,   610,   748,   718,   711,   458,   391,   462,     0,   390,
     456,   314,     0,     0,     0,     0,     0,     0,     0,     0,
     451,   247,   248,   440,   390,   341,   390,   339,     0,    18,
       0,     0,     0,     0,   490,     0,   497,    18,   500,   677,
       0,   592,   664,   662,   665,    18,     0,    18,   598,     0,
     594,     0,     0,     0,     0,     0,     0,     0,     0,   606,
     620,   191,   195,     0,     0,   752,     0,     0,   390,   390,
     323,   327,   325,   390,   466,   326,   348,   346,   347,   352,
       0,   461,   460,   390,   390,   390,   390,   467,     0,     0,
     114,   486,     0,     0,     0,   481,   485,   488,   499,     0,
       0,     0,    18,     0,     0,     0,    18,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   681,   660,     0,   666,     0,     0,   604,   605,
     603,   602,   196,   192,   614,   612,   611,     0,     0,   615,
     617,   618,   619,   197,   609,     0,     0,     0,     0,    18,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   751,   743,     0,   463,   315,   457,   363,
     328,     0,   390,     0,     0,     0,     0,     0,   390,   340,
       0,     0,     0,    18,   626,   668,   658,     0,     0,     0,
       0,     0,   653,    18,   659,     0,   642,   622,   625,   623,
       0,   640,     0,   627,   629,   630,   631,   632,   633,   634,
     635,   636,    18,   647,   648,   649,    18,   624,     0,    18,
     679,   667,   663,     0,     0,   613,   616,     0,     0,     0,
       0,   724,    18,    18,     0,   719,   722,   723,   741,     0,
       0,     0,   736,    18,   744,   746,   745,   747,   742,     0,
     721,   720,     0,     0,    18,   725,    18,    18,   749,   324,
     390,   349,   362,   353,     0,     0,     0,     0,     0,   482,
     483,   484,   643,     0,   651,   650,   652,   163,   164,   654,
     655,     0,   656,    18,   639,   628,   638,   641,   644,   637,
     190,   192,     0,     0,     0,     0,     0,   194,   740,   729,
     731,   734,   737,   735,     0,   738,   733,   730,   732,   726,
     727,   728,     0,   471,   469,   470,   468,   333,   646,   670,
     669,   657,   645,   193,   197,    28,     0,     0,     0,     0,
     739,   671,     0,   202,   197,   197,   197,   197,   672,   198,
     199,   200,   201
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1374, -1374, -1374, -1374,   -39,  -210,    79,  -269,  -912,  -146,
    -720, -1374,  -580,   -82, -1374, -1374, -1374, -1374, -1374,  1269,
     974, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   440,  1473, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374,  -301, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,  1019,  -101,  1577, -1374,    76,  -323, -1374, -1374,
   -1374, -1374,   747,  -585,   569, -1374, -1374,   304, -1374, -1374,
   -1374, -1374,  -173, -1374,   852,   175, -1374,   850, -1012,   178,
   -1373, -1374,  -658, -1374, -1374, -1374, -1374,  -126, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,  -246, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374,   556,  1479, -1374, -1374, -1374, -1374,  -846,
     785,   626,  1278,  1115,  1483, -1374,   973, -1374, -1374,  -973,
   -1374,   421,  -185,  1053,   319, -1024,   819, -1270, -1248,  1678,
   -1196,  1065,   321, -1374, -1374,  -174,  1059, -1374, -1374, -1374,
   -1374,  -376,   680, -1374, -1374,  -963, -1374,  -157,   707,   -17,
   -1374, -1374,   539,   854,   605,  -932, -1374, -1374, -1374, -1374,
     803, -1374, -1374,   573, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   964, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374,   558, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
     525, -1374, -1374, -1374, -1374, -1374,   130, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374,   922, -1374, -1374, -1374, -1374, -1374,
   -1374, -1374, -1374, -1374, -1374, -1374, -1154
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    89,   549,   558,   550,   390,   925,   988,
     989,   774,  1696,   205,   702,    90,   537,   206,   540,   530,
     531,    91,   214,   215,    92,    93,    20,    21,    22,    23,
      24,    25,   134,   354,    94,  1181,   337,    95,   343,   338,
      96,   569,    97,   572,   881,    98,   562,    99,   100,   580,
     101,   102,   230,   256,   596,  1078,   895,   585,   103,   890,
    1225,  1075,   891,  1313,  1314,   855,   856,  1562,   104,   105,
     589,   257,   348,   711,   712,   363,   722,   723,  1430,  1593,
    1431,  1432,  1600,    26,    27,    28,    29,   384,    30,    31,
      32,   375,   750,    33,   372,   735,    34,   376,   365,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,   198,   533,    48,    49,    50,    51,    52,    53,
      54,    55,    56,   128,   369,   106,   570,   107,   871,   872,
     873,  1070,   897,   898,   597,   884,   875,   108,   575,  1217,
    1218,  1380,   187,   436,  1446,   805,   806,   437,  1211,   807,
     438,   439,  1449,   440,  1450,   188,   442,   443,  1382,   406,
     189,   407,   416,   190,   191,   192,  1176,   193,   503,  1209,
    1177,  1291,  1292,   786,   787,  1219,   109,  1085,   903,   110,
    1231,  1405,  1359,  1316,  1232,  1234,  1319,  1363,  1408,  1236,
      57,   111,   626,   112,   113,   114,   311,   312,   313,   966,
    1144,  1260,  1265,  1263,  1264,  1369,  1419,  1145,  1371,  1433,
    1146,  1494,  1368,  1413,  1414,  1497,  1643,  1702,  1690,  1252,
    1270,  1322,  1365,  1410,  1367,  1253,  1006,    58,    59,    60,
      61,    62,    63,    64,    65,   763,   115,   116,   117,  1153,
     970,   118,  1271,  1435,  1535,  1618,  1434,  1373,  1272,    66,
      67,   119,   120,   326,   977,   978,   327,  1179,   979,   688,
      68,   121,    69,   122,   123,   124,   504
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     194,   435,   660,   225,   892,   625,   628,   559,   408,   391,
     392,   300,   441,   310,   414,   318,  1175,  1208,  1396,   325,
     538,  1288,   339,   344,   777,   778,  1002,   779,   387,   781,
     782,  -311,   401,   388,   389,   551,   402,  1069,     1,  1439,
    -311,  -311,  -311,  -311,  1161,   886,   403,  1178,  1440,  1441,
    1442,  1045,  1279,    70,   401,   388,   389,  1355,   402,   772,
     388,   389,  1156,   506,   507,   508,   509,   510,   403,   226,
     582,   135,  1440,  1441,  1442,  1045,  1162,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   143,   412,   520,   506,
     507,   508,   509,   510,   812,   813,   370,   228,  1440,  1441,
    1442,  1045,  1175,   511,   512,   513,   514,   515,   516,   517,
     518,   519,  1447,  1510,   520,   720,  -310,   926,  1317,   506,
     507,   508,   509,   510,   385,  -310,  -310,  -310,  -310,  1161,
    1594,  1583,   936,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   541,   541,   520,  1163,   542,   542,  1459,   649,
     541,   195,   541,   721,   542,   541,   542,  1161,   417,   542,
     196,  1162,   543,   544,   545,   546,   386,   926,   429,   142,
     552,   601,   543,   544,   545,   546,   676,   557,   557,   506,
     507,   508,   509,   510,   614,  1378,  1448,   200,   563,  1162,
     564,   565,   566,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   541,   907,   520,   541,   542,   155,   587,   542,
    1062,   430,   431,   432,   169,   433,   229,  1164,  1165,  1166,
    1167,  1168,  1169,  1170,   345,   543,   544,   545,   546,   749,
    1163,   541,   541,   346,   624,   542,   542,  1171,   360,   563,
    1172,   564,   565,   566,   408,  1276,   408,   361,   408,   408,
     927,   760,   893,   761,   762,  1175,   765,   767,  1163,   769,
     770,   937,   506,   507,   508,   509,   510,   663,   541,   156,
    1059,   371,   542,  1447,   607,  1508,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   889,  1309,   520,  1594,   541,
     541,   887,   218,   542,   542,   541,   696,   201,   202,   542,
     927,   413,  1164,  1165,  1166,  1167,  1168,  1169,  1170,   543,
     544,   545,   546,   378,   716,   543,   544,   545,   546,  1339,
    1620,  1602,  1171,  1511,   952,  1172,  1512,   588,   650,   553,
    1164,  1165,  1166,  1167,  1168,  1169,  1170,   844,   541,   764,
    1318,  1584,   542,   547,  1585,   219,   615,  1448,   216,  1614,
    1171,   622,   921,  1172,   972,  1224,   590,  1158,   543,   544,
     545,   546,   567,   220,  1572,   217,   643,   554,   555,  1621,
    1458,   608,   876,   539,  1069,   654,   810,   656,  1175,   811,
     598,   221,  1173,   661,   915,   916,   664,   780,   430,   431,
     432,  1045,   433,   785,   201,   202,  1603,  1063,  1493,   573,
     415,   794,   795,   796,   797,   798,  1437,  1397,   690,  1381,
     692,   974,   404,   975,  1411,   222,  1175,   808,   405,   203,
    -311,   224,  1534,   223,  -311,  1280,   773,   541,  1443,   602,
     204,   542,  1444,   987,   404,   908,  1420,   592,   593,   227,
     405,  1688,   506,   507,   508,   509,   510,   543,   544,   545,
     546,   802,  1630,   353,   841,   803,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   814,  1539,   520,  1159,   928,
     430,   431,   432,  1045,   433,  1175,  1175,   987,  1443,  1415,
     129,  1029,   815,  1644,  1645,   816,   877,   878,   879,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,  1312,  1024,  -310,  1381,   378,   557,  -310,
     630,  1032,   730,   197,   846,   232,   388,   389,   840,  1244,
     631,   854,   548,   548,  1638,   506,   507,   508,   509,   510,
     548,   845,   548,   766,   623,   548,   350,  1174,  1345,   511,
     512,   513,   514,   515,   516,   517,   518,   519,  1266,  1346,
     520,   857,   894,  1495,   595,   378,   351,  1558,  1559,   894,
    1496,   894,  1615,   136,   137,   140,   141,  1597,   568,  1632,
     349,  1033,  1399,   352,   207,   199,  1037,   914,   900,  1175,
    1038,  1130,   548,   541,   355,   548,   347,   542,   929,   998,
     931,   434,  1663,   934,  1664,   731,   938,   939,   618,  1624,
     362,  1258,  1598,   543,   544,   545,   546,  1616,  1617,   364,
    1067,   548,   548,   356,   506,   507,   508,   509,   510,   568,
     590,  1665,  1416,  1666,   435,   435,   965,   359,   511,   512,
     513,   514,   515,   516,   517,   518,   519,    71,  1017,   520,
    1019,   441,  1118,   373,   591,  1417,  1599,   377,   548,   208,
     981,  1198,   982,  1542,  1034,   209,  1543,   732,   374,   379,
    1651,   986,   888,  1558,  1559,   388,   389,  1321,    72,   548,
     548,   378,   733,   627,   901,   548,   902,    73,  1400,  1401,
      74,   393,  1402,  1403,   734,   233,   394,   210,   906,   909,
     234,    75,   201,   202,   357,   358,   917,   395,   919,   396,
    1418,   592,   593,   619,    76,   397,   211,  1157,   398,  1186,
     594,   399,  1187,  1560,    77,  1189,   940,   400,   548,   129,
      78,   945,   380,   947,   880,   951,   410,   953,   409,   620,
     956,   957,   958,  1023,   235,  1255,  1256,   411,   962,   418,
    1072,   963,   165,   419,   166,   167,   168,   169,   170,   171,
      79,  1561,    80,    81,   971,   130,   172,   173,   804,   174,
      82,   175,   212,   131,   132,   133,   420,   236,  1046,   421,
    1257,   422,   983,   984,   985,   506,   507,   508,   509,   510,
    1133,   534,   948,   423,  1039,   532,  1040,    83,    84,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   535,    85,
     520,   536,  1084,   556,   518,   519,   987,   548,   520,   560,
     949,   950,   561,  1235,   635,   636,  1674,   571,   595,  1610,
     639,   640,    86,   213,   574,    87,   506,   507,   508,   509,
     510,   576,  1404,   577,  1036,  1134,   578,  1066,  1008,   579,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   176,
     434,   520,   647,   648,  1009,   177,   237,  1611,   583,   506,
     507,   508,   509,   510,   581,  1086,  1087,   584,  1089,  1152,
     408,   670,   671,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   125,   126,   520,   366,   367,  1103,  1104,   381,
     705,  1106,  1007,  1108,  1109,  1018,  1111,  1020,   586,  1021,
    1022,   600,  1117,   382,   383,  1227,   837,   838,   127,   603,
     178,   179,   506,   507,   508,   509,   510,  1206,   125,   126,
     604,  1131,  1135,   679,   238,  1132,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   605,   831,   520,   606,   706,
     707,   851,   852,   853,   127,   180,   181,   424,   425,   426,
     427,  1010,   708,   709,   987,   710,  1228,  1229,  1230,   832,
    1328,   610,   182,   548,   611,   183,   612,   833,   157,   609,
     184,   613,   834,   835,   836,   616,  1136,   617,  1079,   847,
     848,   239,   366,   367,   849,   850,   240,   680,   990,   991,
    1092,   993,   994,  1262,   388,   389,   973,  1097,   621,  1099,
    1137,   241,  1138,  1055,   838,  1385,  1302,  1139,   368,  1140,
    1462,  1463,   785,  1141,  1142,  1201,  1202,  1203,   681,  1204,
     629,  1205,   388,   389,  1223,   632,  1212,   682,    88,  1213,
     158,   634,   159,   160,   637,  1215,  1703,   638,   165,   633,
     166,   167,   168,   169,   170,   171,  1709,  1710,  1711,  1712,
    1349,  1350,   172,   173,   641,   174,  1143,   175,   646,   642,
    1386,  1387,   138,   139,   165,   645,   166,   167,   168,   169,
     170,   171,   651,   161,   162,   163,   164,   644,   172,   173,
     655,   174,   653,   175,  1697,  1698,  1699,   506,   507,   508,
     509,   510,   659,  1406,   791,   792,   652,  1161,   657,  1011,
     662,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     658,  1274,   520,   665,   231,  1388,   683,   684,   685,   686,
    1278,  1389,   666,   242,   185,   667,   669,   672,   258,  1162,
     259,   186,   301,   677,   314,   668,   319,   673,   320,   674,
     675,  1293,   678,   687,  1012,   176,   689,  1190,  1013,  1192,
    1283,   177,   691,   693,  1284,  1285,   694,   695,   697,   698,
    1290,   700,   701,  1014,   713,  1342,   506,   507,   508,   509,
     510,   176,   715,   699,   717,   718,   703,   177,   704,   719,
     511,   512,   513,   514,   515,   516,   517,   518,   519,  1303,
     724,   520,  1465,   725,  1015,  1016,   726,  1445,  1163,  1320,
     728,   729,   768,   771,   775,   776,   178,   179,   783,   788,
     784,   789,   790,  1254,  1028,  1259,  1323,  1324,   793,  1326,
     799,  1267,  1412,   520,  1412,   800,   809,  1331,  1273,   801,
    1332,   839,   178,   179,   883,   843,  1361,  1277,   858,   882,
     885,   180,   181,   424,   425,   426,   427,  1035,   899,   904,
     910,  1607,  1286,   905,   911,   912,   913,   920,   182,   918,
     924,   183,  1336,   785,  1338,   922,   184,   180,   181,   923,
    1164,  1165,  1166,  1167,  1168,  1169,  1170,   930,   932,   942,
     933,   935,   941,   943,   182,  1351,   960,   183,  1212,   944,
    1171,   946,   184,  1172,   954,   955,  1374,   959,   967,   752,
    1044,   961,  1421,   964,   165,   968,   166,   167,   168,   169,
     170,   171,   969,   976,   980,   753,   992,   995,   172,   173,
     804,   174,   996,   175,  1422,   997,   999,  1383,  1384,  1004,
    1290,  1000,  1025,  1030,  1003,  1026,  1325,  1423,  1005,  1502,
    1639,  1640,  1641,  1574,  1575,  1576,  1577,  1578,  1579,  1580,
    1581,   506,   507,   508,   509,   510,  1445,  1027,  1445,  1031,
    1041,  1042,  1043,   557,  1466,   511,   512,   513,   514,   515,
     516,   517,   518,   519,  1689,  1049,   520,  1499,  1052,  1212,
    1050,   243,   754,  1057,  1504,  1505,  1506,  1058,  1509,  1060,
    1065,   165,  1064,   166,   167,   168,   169,   170,   171,  1073,
    1161,   321,  1074,  1076,  1077,   172,   173,  1088,   174,  1090,
     175,   176,  1091,  1101,   755,   756,  1093,   177,  1094,  1180,
     185,   245,   757,  1095,  1096,  1184,  1540,   186,  1098,  1100,
    1105,  1554,  1162,  1107,  1185,  1110,  1544,  1545,  1546,  1547,
    1567,  1568,  1569,  1112,  1571,  1573,   185,  -454,  1113,   758,
    1587,   246,  1114,   186,  1188,   247,   248,  1591,  1115,   250,
     251,  1116,  1119,  1120,  1121,   252,  1191,  1122,  1595,  1596,
    1193,  1123,   178,   179,  1124,  1056,  1601,  -310,  1461,  1605,
    1125,  1126,  1127,  1128,  1129,  1194,  1468,   759,  1424,  1425,
    1426,  1625,  1427,  1147,  1498,   253,  1500,  1154,   176,  1155,
     254,  1163,  1195,  1428,   177,  1196,  1200,   180,   181,  1197,
    1214,   557,   557,   557,   322,  1220,  1221,  1222,  1646,  1647,
    1648,  1649,  1650,  1237,   182,  1238,  1239,   183,  1240,  1241,
    1242,  1654,   184,  1655,  1243,   896,   859,   860,   861,   862,
     863,   864,   865,  1245,   866,   867,   868,   869,   870,  1658,
    1246,  1556,  1261,  1247,  1061,  1564,  1248,  1566,  1662,   178,
     179,  1249,  1250,  1281,  1429,  1670,  1294,  1295,  1269,  1251,
    1671,  1672,  1673,  1164,  1165,  1166,  1167,  1168,  1169,  1170,
    1676,  1282,  1296,  1677,  1678,  1268,  1275,  1297,  1306,  1305,
    1289,  1311,  1335,  1171,   180,   181,  1172,  1344,  1606,  1353,
    1608,   165,  1343,   166,   167,   168,   169,   170,   171,  1304,
    1308,   182,  1315,  1682,   183,   172,   173,  1354,   174,   184,
     175,  1327,   165,  1329,   166,   167,   168,   169,   170,   171,
    1330,  1333,  1642,  1348,   323,  1347,   172,   173,  1360,   174,
    1356,   175,  1652,   521,   522,   523,   524,   525,   526,   527,
     528,   529,  1357,  1362,  1364,   506,   507,   508,   509,   510,
    1366,  1656,  1372,  1376,  1391,  1657,  1392,  1394,  1659,   511,
     512,   513,   514,   515,   516,   517,   518,   519,  1395,  1398,
     520,  1668,  1669,  1407,  1436,  1438,   185,  1453,  1454,  1455,
    1456,  1457,  1675,   186,  1460,  1464,  1467,  1503,  1501,  1513,
    1514,  1507,  1536,  1679,  1537,  1680,  1681,  1541,   176,  1548,
    1550,  1551,  1549,  1552,   177,   859,   860,   861,   862,   863,
     864,   865,  1553,   866,   867,   868,   869,   870,  1563,   176,
    1555,  1557,  1692,  1068,   324,   177,  1565,  1570,  1582,  1207,
     506,   507,   508,   509,   510,  1586,  1588,  1589,  1590,  1592,
    1421,  1604,  1609,  1613,   511,   512,   513,   514,   515,   516,
     517,   518,   519,  1619,  1622,   520,  1623,  1626,  1627,   178,
     179,  1628,  -449,   185,  1661,  1653,  1683,  1684,  1660,  1379,
     186,   506,   507,   508,   509,   510,  1667,  1685,  1687,  1686,
     178,   179,  1691,  1701,  1694,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   180,   181,   520,  1695,   842,  1704,
    1705,  1700,  1053,  1706,  1707,  1708,   506,   507,   508,   509,
     510,   182,   714,  1226,   183,   180,   181,  1612,   599,   184,
     511,   512,   513,   514,   515,   516,   517,   518,   519,  1693,
    1334,   520,   182,  1182,  1183,   183,  1310,   727,   874,  1216,
     184,   506,   507,   508,   509,   510,  1001,  1071,   751,  1538,
    1631,  1210,  1047,   428,  1633,   511,   512,   513,   514,   515,
     516,   517,   518,   519,  1051,  1048,   520,   506,   507,   508,
     509,   510,  1287,  1199,  1233,  1337,  1390,  1358,  1370,  1102,
    1409,   511,   512,   513,   514,   515,   516,   517,   518,   519,
    1160,     0,   520,   506,   507,   508,   509,   510,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   511,   512,   513,
     514,   515,   516,   517,   518,   519,     0,     0,   520,   506,
     507,   508,   509,   510,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   511,   512,   513,   514,   515,   516,   517,
     518,   519,     0,     0,   520,   506,   507,   508,   509,   510,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,     0,
     520,     0,     0,   185,     0,     0,     0,     0,     0,     0,
     186,     0,     0,     0,     0,     0,     0,     0,   506,   507,
     508,   509,   510,     0,   185,     0,     0,     0,     0,     0,
       0,   186,   511,   512,   513,   514,   515,   516,   517,   518,
     519,     0,     0,   520,     0,     0,     0,     0,     0,     0,
     506,   507,   508,   509,   510,     0,     0,     0,     0,     0,
       0,     0,     0,  1298,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,     0,   520,   506,   507,   508,   509,
     510,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
       0,   520,   506,   507,   508,   509,   510,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,     0,   520,     0,     0,
       0,     0,     0,     0,     0,   506,   507,   508,   509,   510,
       0,     0,     0,     0,     0,     0,     0,     0,  1299,   511,
     512,   513,   514,   515,   516,   517,   518,   519,     0,     0,
     520,   506,   507,   508,   509,   510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,     0,   520,     0,     0,  1300,
     506,   507,   508,   509,   510,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   511,   512,   513,   514,   515,   516,
     517,   518,   519,     0,     0,   520,   506,   507,   508,   509,
     510,     0,     0,     0,  1301,     0,     0,     0,  1515,     0,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
       0,   520,     0,   243,     0,     0,   506,   507,   508,   509,
     510,     0,  1516,  1517,     0,     0,     0,     0,     0,  1307,
     511,   512,   513,   514,   515,   516,   517,   518,   519,     0,
       0,   520,     0,  1518,     0,     0,   506,   507,   508,   509,
     510,     0,   444,   245,     0,  1352,     0,     0,     0,     0,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   144,
     145,   520,     0,     0,     0,     0,     0,     0,     0,   146,
       0,  1393,     0,   246,     0,     0,     0,   247,   248,     0,
    1080,   250,   251,  1421,   147,  1519,     0,   252,     0,     0,
       0,     0,     0,   148,     0,   149,   150,  1629,     0,     0,
       0,     0,     0,     0,  1520,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   253,     0,   445,
     446,     0,   254,  1634,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,     0,     0,   243,     0,     0,     0,     0,
     151,     0,   505,     0,     0,     0,  1635,   506,   507,   508,
     509,   510,     0,     0,     0,   475,     0,     0,     0,     0,
       0,   511,   512,   513,   514,   515,   516,   517,   518,   519,
    1521,     0,   520,  1522,  1523,   245,     0,     0,  1636,     0,
       0,   506,   507,   508,   509,   510,   476,     0,  1081,  1082,
       0,     0,     0,   243,     0,   511,   512,   513,   514,   515,
     516,   517,   518,   519,  1637,   246,   520,     0,   152,   247,
     248,     0,  1148,   250,   251,     0,     0,     0,     0,   252,
     328,   329,   330,     0,   331,   332,     0,   333,  1054,  1524,
       0,   334,     0,   245,   335,     0,     0,     0,     0,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   253,
       0,     0,     0,     0,   254,     0,     0,     0,     0,     0,
     444,  1340,     0,   246,  1525,     0,     0,   247,   248,     0,
     153,   250,   251,     0,     0,     0,     0,   252,     0,     0,
    1526,     0,     0,     0,     0,   154,     0,  1375,   486,   487,
     488,   489,   490,   491,   492,   493,   494,  1527,     0,     0,
       0,     0,  1528,  1529,     0,  1530,  1531,   253,  1532,     0,
       0,     0,   254,     0,   495,   496,  1377,     0,   859,   860,
     861,   862,   863,   864,   865,  1533,   866,   867,   868,   869,
     870,   497,   498,   499,   500,     0,  1083,   445,   446,     0,
       0,     0,  1451,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,     0,  1452,     0,     0,   243,     0,     0,     0,     0,
     260,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,     0,     0,     0,     0,   261,     0,   243,     0,   243,
       0,     0,     0,     0,   501,   502,     0,     0,     0,   262,
       0,  -455,  -455,  -455,     0,   245,     0,     0,     0,     0,
       0,   243,     0,     0,   476,  -455,  -455,  -455,  -455,  -455,
     516,   517,   518,   519,     0,   302,   520,   245,     0,   245,
       0,   244,     0,  1149,     0,   246,     0,     0,     0,   247,
     248,   263,   264,   250,   251,     0,     0,     0,     0,   252,
       0,   245,     0,   265,  1150,     0,   266,   246,   267,   246,
       0,   247,   248,   247,   248,   250,   251,   250,   251,     0,
       0,   252,     0,   252,     0,     0,     0,     0,  1151,   253,
       0,   246,     0,     0,   254,   247,   248,     0,   249,   250,
     251,     0,     0,     0,     0,   252,     0,     0,   268,     0,
     269,   253,     0,   253,     0,     0,   254,     0,   254,   270,
       0,     0,     0,     0,     0,     0,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   253,     0,     0,     0,     0,
     254,     0,     0,     0,     0,     0,   336,     0,     0,     0,
       0,     0,   495,   496,     0,   271,     0,     0,     0,  1469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   497,
     498,   499,   500,   272,     0,   243,     0,     0,     0,     0,
     273,   274,     0,   275,     0,   276,   277,     0,   278,   279,
       0,   280,     0,     0,   281,   282,   283,     0,     0,     0,
       0,     0,     0,     0,   340,     0,     0,     0,     0,   284,
     285,     0,     0,     0,   286,   245,   287,   288,     0,   289,
       0,     0,     0,     0,   290,     0,     0,     0,   291,   292,
    1421,   293,   294,     0,   295,   296,   297,     0,     0,     0,
     298,     0,   501,   502,     0,   246,   736,     0,     0,   247,
     248,     0,  1422,   250,   251,     0,     0,     0,     0,   252,
       0,   388,   389,     0,   303,  1470,     0,     0,     0,   304,
     305,   306,     0,     0,   341,     0,     0,     0,     0,  1471,
       0,   506,   507,   508,     0,     0,     0,     0,   737,   253,
       0,     0,     0,     0,   254,   511,   512,   513,   514,   515,
     516,   517,   518,   519,     0,   307,   520,     0,     0,     4,
       0,     0,   308,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   315,   316,     0,     0,     0,   299,   738,
       0,     0,     0,     0,     5,     6,     0,  1472,     0,     0,
    1473,  1474,     0,     0,     7,     0,     0,     0,     0,     0,
     309,     0,   317,     0,     0,     0,     0,     0,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,   740,   741,
       0,     0,     0,     0,   255,     0,     0,     0,     0,   742,
       0,     0,     0,     0,     0,     0,     0,     0,   743,   744,
     745,   746,     0,   747,   748,     0,  1475,     8,     0,  1476,
       0,     0,  1477,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1478,     0,  1479,     0,  1480,  1481,  1482,  1483,
    1484,  1485,     0,     0,     0,     9,     0,  1486,    10,     0,
      11,  1487,  1488,     0,     0,  1489,     0,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,  1490,     0,     0,
       0,    17,    18,    19,     0,  1491,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   595,     0,     0,     0,
       0,     0,  1492,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   342
};

static const yytype_int16 yycheck[] =
{
      17,   186,   303,    85,   589,   274,   275,   217,   165,   155,
     156,   112,   186,   114,    15,   116,   979,  1041,     7,   120,
      45,  1175,   123,   124,     7,   401,   746,   403,   154,   405,
     406,     6,    15,    18,    19,   208,    19,   883,     4,     6,
      15,    16,    17,    18,    19,   153,    29,   979,    15,    16,
      17,    18,    22,     0,    15,    18,    19,  1305,    19,    30,
      18,    19,   974,     8,     9,    10,    11,    12,    29,    86,
     243,     3,    15,    16,    17,    18,    51,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   153,    28,    33,     8,
       9,    10,    11,    12,    27,    28,     3,    19,    15,    16,
      17,    18,  1065,    22,    23,    24,    25,    26,    27,    28,
      29,    30,  1382,   127,    33,   128,     6,    42,    31,     8,
       9,    10,    11,    12,   144,    15,    16,    17,    18,    19,
    1503,   127,   135,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    15,    15,    33,   120,    19,    19,  1396,   122,
      15,    36,    15,   166,    19,    15,    19,    19,   175,    19,
      45,    51,    35,    36,    37,    38,   186,    42,   185,     3,
     209,   253,    35,    36,    37,    38,   322,   216,   217,     8,
       9,    10,    11,    12,   266,  1339,  1382,    19,    15,    51,
      17,    18,    19,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    15,    76,    33,    15,    19,   153,   247,    19,
      19,    15,    16,    17,    18,    19,   138,   192,   193,   194,
     195,   196,   197,   198,    36,    35,    36,    37,    38,   375,
     120,    15,    15,    45,   273,    19,    19,   212,    36,    15,
     215,    17,    18,    19,   401,  1157,   403,    45,   405,   406,
     175,   377,    36,   379,   380,  1218,   382,   383,   120,   385,
     386,   264,     8,     9,    10,    11,    12,   306,    15,   153,
     855,   178,    19,  1543,   172,   147,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   586,  1218,    33,  1661,    15,
      15,   399,    81,    19,    19,    15,   335,    19,    20,    19,
     175,   242,   192,   193,   194,   195,   196,   197,   198,    35,
      36,    37,    38,    19,   353,    35,    36,    37,    38,  1282,
     329,   309,   212,   337,   647,   215,   340,   248,   301,    20,
     192,   193,   194,   195,   196,   197,   198,   547,    15,    45,
     253,   337,    19,    69,   340,    19,   267,  1543,    50,   127,
     212,   272,   621,   215,   677,  1075,    45,   244,    35,    36,
      37,    38,   138,   117,   147,    67,   287,    58,    59,   378,
    1394,   269,    42,   398,  1220,   296,   400,   298,  1341,   403,
      69,    19,   244,   304,   247,   248,   307,   404,    15,    16,
      17,    18,    19,   410,    19,    20,   384,   206,  1410,   224,
     401,   418,   419,   420,   421,   422,  1379,   396,   329,  1341,
     331,   680,   395,   682,   399,    86,  1379,   434,   401,    44,
     395,   143,  1434,   155,   399,   395,   397,    15,   395,   254,
      55,    19,   399,   702,   395,   308,   399,   126,   127,    19,
     401,   399,     8,     9,    10,    11,    12,    35,    36,    37,
      38,   396,   395,    67,   536,   400,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   398,  1439,    33,   355,   394,
      15,    16,    17,    18,    19,  1438,  1439,   746,   395,   178,
      20,   400,   400,   348,   349,   403,   156,   157,   158,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,  1223,   773,   395,  1438,    19,   547,   399,
     258,   400,     3,   398,   553,   398,    18,    19,   535,   394,
     268,   560,   395,   395,  1548,     8,     9,    10,    11,    12,
     395,   548,   395,    45,   394,   395,     3,   399,    22,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   358,    33,
      33,   568,   591,   344,   243,    19,     3,   170,   171,   598,
     351,   600,   340,     7,     8,     9,    10,   117,   395,  1542,
     130,   400,   139,   133,    68,    19,   396,   616,   595,  1542,
     400,   394,   395,    15,     3,   395,   398,    19,   627,   735,
     629,   395,   138,   632,   140,    86,   635,   636,   179,   346,
     398,   321,   152,    35,    36,    37,    38,   385,   386,    86,
     879,   395,   395,     3,     8,     9,    10,    11,    12,   395,
      45,   138,   321,   140,   809,   810,   665,     3,    22,    23,
      24,    25,    26,    27,    28,    29,    30,     3,   764,    33,
     766,   815,   943,     3,    69,   344,   196,   255,   395,   143,
     689,  1027,   691,   397,   400,   149,   400,   148,     3,   123,
     248,   700,   583,   170,   171,    18,    19,  1252,    34,   395,
     395,    19,   163,   175,   598,   395,   600,    43,   245,   246,
      46,     3,   249,   250,   175,    73,     3,    43,   609,   610,
      78,    57,    19,    20,   138,   139,   617,     3,   619,     3,
     399,   126,   127,   284,    70,     3,    62,   976,     3,  1010,
     135,     3,  1013,   326,    80,  1016,   637,     3,   395,    20,
      86,   642,   186,   644,   394,   646,   395,   648,    30,   310,
     651,   652,   653,   772,   122,   321,   322,   242,   659,   395,
     886,   662,    13,   395,    15,    16,    17,    18,    19,    20,
     116,   364,   118,   119,   675,    56,    27,    28,    29,    30,
     126,    32,   118,    64,    65,    66,   395,   155,   395,   395,
     356,   395,   693,   694,   695,     8,     9,    10,    11,    12,
     123,     3,   264,   395,   801,    15,   803,   153,   154,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    22,   165,
      33,    63,   903,   394,    29,    30,  1075,   395,    33,   172,
     292,   293,   161,  1082,   272,   273,   248,    19,   243,   326,
     282,   283,   188,   179,   394,   191,     8,     9,    10,    11,
      12,   138,   399,    19,   400,   178,   398,   876,     3,   398,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   120,
     395,    33,    86,    87,    19,   126,   244,   364,   309,     8,
       9,    10,    11,    12,   398,   904,   905,    19,   907,   970,
    1027,   372,   373,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    19,    20,    33,    19,    20,   926,   927,   353,
      79,   930,   762,   932,   933,   765,   935,   767,   117,   769,
     770,    69,   941,   367,   368,    81,   399,   400,    45,   394,
     181,   182,     8,     9,    10,    11,    12,   400,    19,    20,
     394,   960,   265,   197,   312,   964,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   398,   201,    33,   398,   128,
     129,    39,    40,    41,    45,   216,   217,   218,   219,   220,
     221,   116,   141,   142,  1223,   144,   132,   133,   134,   224,
    1261,    81,   233,   395,   394,   236,    20,   232,    79,   309,
     241,   270,   237,   238,   239,    69,   319,    85,   899,    60,
      61,   369,    19,    20,    60,    61,   374,   261,   399,   400,
     911,   399,   400,  1139,    18,    19,    20,   918,   158,   920,
     343,   389,   345,   399,   400,   126,   400,   350,    45,   352,
     247,   248,  1029,   356,   357,  1032,  1033,  1034,   292,  1036,
      76,  1038,    18,    19,    20,    76,  1043,   301,   394,  1046,
     141,   263,   143,   144,    87,  1052,  1694,   268,    13,   256,
      15,    16,    17,    18,    19,    20,  1704,  1705,  1706,  1707,
    1296,  1297,    27,    28,   282,    30,   399,    32,   296,   286,
     181,   182,   163,   164,    13,   291,    15,    16,    17,    18,
      19,    20,    87,   184,   185,   186,   187,   289,    27,    28,
     254,    30,   302,    32,  1664,  1665,  1666,     8,     9,    10,
      11,    12,   352,  1362,   414,   415,   304,    19,   394,   264,
     116,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     398,  1150,    33,   117,    95,   236,   390,   391,   392,   393,
    1159,   242,   394,   104,   395,   398,    86,   394,   109,    51,
     111,   402,   113,    86,   115,   398,   117,   398,   119,   398,
     309,  1180,   394,   398,   309,   120,    86,  1017,   313,  1019,
    1167,   126,    76,    79,  1171,  1172,    81,    85,   394,   394,
    1177,    76,    20,   328,     3,   398,     8,     9,    10,    11,
      12,   120,     3,   394,     3,     3,   394,   126,   394,     3,
      22,    23,    24,    25,    26,    27,    28,    29,    30,  1206,
       3,    33,  1402,    19,   359,   360,     3,  1382,   120,  1238,
       3,     3,     3,     3,   173,   173,   181,   182,    14,    27,
      15,   242,    28,  1134,   396,  1136,  1255,  1256,    30,  1258,
      19,  1142,  1368,    33,  1370,    15,     7,  1266,  1149,   400,
    1269,     3,   181,   182,   395,   394,  1318,  1158,   394,   394,
      19,   216,   217,   218,   219,   220,   221,   396,   136,    76,
     394,  1520,  1173,    76,    51,   394,   394,   166,   233,   294,
      31,   236,  1279,  1280,  1281,   394,   241,   216,   217,   394,
     192,   193,   194,   195,   196,   197,   198,   175,    76,   394,
      76,    76,    76,   117,   233,  1302,   175,   236,  1305,   394,
     212,   394,   241,   215,   394,   394,  1335,   394,    19,     3,
     396,   394,   137,    69,    13,   394,    15,    16,    17,    18,
      19,    20,   394,   261,   394,    19,     3,     3,    27,    28,
      29,    30,    19,    32,   159,    15,    19,  1344,  1345,     3,
    1347,    19,    15,   396,    19,    15,  1257,   172,    20,  1421,
    1550,  1551,  1552,   329,   330,   331,   332,   333,   334,   335,
     336,     8,     9,    10,    11,    12,  1541,    15,  1543,    28,
       7,   400,   400,  1402,  1403,    22,    23,    24,    25,    26,
      27,    28,    29,    30,  1643,    15,    33,  1416,   395,  1396,
      18,    46,    86,    20,  1423,  1424,  1425,   394,  1427,   394,
     398,    13,   394,    15,    16,    17,    18,    19,    20,   394,
      19,    66,    28,   400,   131,    27,    28,   394,    30,   394,
      32,   120,   394,    19,   118,   119,   394,   126,   394,    69,
     395,    86,   126,   394,   394,     3,  1443,   402,   394,   394,
     394,  1470,    51,   394,     3,   394,  1453,  1454,  1455,  1456,
    1479,  1480,  1481,   394,  1483,  1484,   395,   396,   394,   153,
    1489,   116,   394,   402,    15,   120,   121,  1496,   394,   124,
     125,   394,   394,   394,   394,   130,     3,   394,  1507,  1508,
       3,   394,   181,   182,   394,   396,  1515,   399,  1399,  1518,
     394,   394,   394,   394,   394,     3,  1407,   191,   323,   324,
     325,  1530,   327,   394,  1415,   160,  1417,   394,   120,   394,
     165,   120,     3,   338,   126,   175,    28,   216,   217,   175,
     400,  1550,  1551,  1552,   179,   394,   396,   173,  1557,  1558,
    1559,  1560,  1561,   394,   233,   400,   394,   236,   394,   394,
     394,  1570,   241,  1572,   394,    19,   199,   200,   201,   202,
     203,   204,   205,   394,   207,   208,   209,   210,   211,  1588,
     394,  1472,   309,   394,   396,  1476,   394,  1478,  1597,   181,
     182,   394,   394,    22,   399,  1604,     3,     3,   361,   394,
    1609,  1610,  1611,   192,   193,   194,   195,   196,   197,   198,
    1619,   395,    15,  1622,  1623,   394,   394,    15,    15,   400,
     394,    15,    69,   212,   216,   217,   215,    22,  1519,     7,
    1521,    13,   394,    15,    16,    17,    18,    19,    20,   396,
     399,   233,   398,  1630,   236,    27,    28,    29,    30,   241,
      32,   398,    13,   398,    15,    16,    17,    18,    19,    20,
     398,   398,  1553,   394,   299,   400,    27,    28,    19,    30,
     399,    32,  1563,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   175,   254,   394,     8,     9,    10,    11,    12,
     398,  1582,   398,   396,     3,  1586,     3,   395,  1589,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   396,    15,
      33,  1602,  1603,   251,   396,   214,   395,   395,   395,   395,
     395,   394,  1613,   402,   394,   248,   394,   398,   394,   398,
     394,   268,   394,  1624,   399,  1626,  1627,     7,   120,   400,
     249,   249,   396,   249,   126,   199,   200,   201,   202,   203,
     204,   205,   309,   207,   208,   209,   210,   211,   304,   120,
     398,   347,  1653,   396,   399,   126,   365,   268,   363,   396,
       8,     9,    10,    11,    12,   331,   355,   329,   394,   394,
     137,    76,   347,   304,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   355,    76,    33,    76,   381,   383,   181,
     182,   394,   394,   395,   394,   366,   394,   394,   399,   398,
     402,     8,     9,    10,    11,    12,   399,   394,   396,   394,
     181,   182,   346,   341,   394,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   216,   217,    33,    20,   539,   394,
     394,   346,   838,   394,   394,   394,     8,     9,    10,    11,
      12,   233,   349,  1076,   236,   216,   217,  1523,   251,   241,
      22,    23,    24,    25,    26,    27,    28,    29,    30,  1661,
    1271,    33,   233,   991,   994,   236,  1220,   368,   570,  1064,
     241,     8,     9,    10,    11,    12,   741,   884,   375,  1438,
    1541,  1042,   809,   185,  1543,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   815,   810,    33,     8,     9,    10,
      11,    12,  1175,  1029,  1081,  1280,  1347,  1314,  1330,   925,
    1365,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     978,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,    -1,   395,    -1,    -1,    -1,    -1,    -1,
      -1,   402,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   396,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   396,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,   396,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,   396,    -1,    -1,    -1,    42,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    46,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,   396,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    87,    -1,    -1,     8,     9,    10,    11,
      12,    -1,     5,    86,    -1,   396,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   143,
     144,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
      -1,   396,    -1,   116,    -1,    -1,    -1,   120,   121,    -1,
     123,   124,   125,   137,   168,   139,    -1,   130,    -1,    -1,
      -1,    -1,    -1,   177,    -1,   179,   180,   396,    -1,    -1,
      -1,    -1,    -1,    -1,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,    -1,    82,
      83,    -1,   165,   396,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,    -1,    46,    -1,    -1,    -1,    -1,
     244,    -1,     3,    -1,    -1,    -1,   396,     8,     9,    10,
      11,    12,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     244,    -1,    33,   247,   248,    86,    -1,    -1,   396,    -1,
      -1,     8,     9,    10,    11,    12,   169,    -1,   251,   252,
      -1,    -1,    -1,    46,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   396,   116,    33,    -1,   312,   120,
     121,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
      73,    74,    75,    -1,    77,    78,    -1,    80,   394,   303,
      -1,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,   222,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   160,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,
       5,   394,    -1,   116,   338,    -1,    -1,   120,   121,    -1,
     374,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
     354,    -1,    -1,    -1,    -1,   389,    -1,   394,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   371,    -1,    -1,
      -1,    -1,   376,   377,    -1,   379,   380,   160,   382,    -1,
      -1,    -1,   165,    -1,   297,   298,   394,    -1,   199,   200,
     201,   202,   203,   204,   205,   399,   207,   208,   209,   210,
     211,   314,   315,   316,   317,    -1,   399,    82,    83,    -1,
      -1,    -1,   394,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,    -1,   394,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    46,    -1,    46,
      -1,    -1,    -1,    -1,   387,   388,    -1,    -1,    -1,    80,
      -1,     8,     9,    10,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,   169,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    84,    33,    86,    -1,    86,
      -1,    66,    -1,   354,    -1,   116,    -1,    -1,    -1,   120,
     121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
      -1,    86,    -1,   134,   375,    -1,   137,   116,   139,   116,
      -1,   120,   121,   120,   121,   124,   125,   124,   125,    -1,
      -1,   130,    -1,   130,    -1,    -1,    -1,    -1,   399,   160,
      -1,   116,    -1,    -1,   165,   120,   121,    -1,   123,   124,
     125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   179,    -1,
     181,   160,    -1,   160,    -1,    -1,   165,    -1,   165,   190,
      -1,    -1,    -1,    -1,    -1,    -1,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   160,    -1,    -1,    -1,    -1,
     165,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,   297,   298,    -1,   226,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,
     315,   316,   317,   244,    -1,    46,    -1,    -1,    -1,    -1,
     251,   252,    -1,   254,    -1,   256,   257,    -1,   259,   260,
      -1,   262,    -1,    -1,   265,   266,   267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,   285,    86,   287,   288,    -1,   290,
      -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,   299,   300,
     137,   302,   303,    -1,   305,   306,   307,    -1,    -1,    -1,
     311,    -1,   387,   388,    -1,   116,     3,    -1,    -1,   120,
     121,    -1,   159,   124,   125,    -1,    -1,    -1,    -1,   130,
      -1,    18,    19,    -1,   313,   172,    -1,    -1,    -1,   318,
     319,   320,    -1,    -1,   145,    -1,    -1,    -1,    -1,   186,
      -1,     8,     9,    10,    -1,    -1,    -1,    -1,    45,   160,
      -1,    -1,    -1,    -1,   165,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   354,    33,    -1,    -1,    46,
      -1,    -1,   361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   370,   371,    -1,    -1,    -1,   399,    86,
      -1,    -1,    -1,    -1,    71,    72,    -1,   244,    -1,    -1,
     247,   248,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
     399,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
      -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,   146,
     147,   148,    -1,   150,   151,    -1,   303,   134,    -1,   306,
      -1,    -1,   309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,    -1,    -1,   162,    -1,   334,   165,    -1,
     167,   338,   339,    -1,    -1,   342,    -1,   174,    -1,   176,
      -1,    -1,    -1,    -1,   181,   182,   183,   354,    -1,    -1,
      -1,   188,   189,   190,    -1,   362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   405,   406,    46,    71,    72,    81,   134,   162,
     165,   167,   174,   176,   181,   182,   183,   188,   189,   190,
     430,   431,   432,   433,   434,   435,   487,   488,   489,   490,
     492,   493,   494,   497,   500,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   594,   631,   632,
     633,   634,   635,   636,   637,   638,   653,   654,   664,   666,
       0,     3,    34,    43,    46,    57,    70,    80,    86,   116,
     118,   119,   126,   153,   154,   165,   188,   191,   394,   407,
     419,   425,   428,   429,   438,   441,   444,   446,   449,   451,
     452,   454,   455,   462,   472,   473,   529,   531,   541,   580,
     583,   595,   597,   598,   599,   640,   641,   642,   645,   655,
     656,   665,   667,   668,   669,    19,    20,    45,   527,    20,
      56,    64,    65,    66,   436,     3,   527,   527,   163,   164,
     527,   527,     3,   153,   143,   144,   153,   168,   177,   179,
     180,   244,   312,   374,   389,   153,   153,    79,   141,   143,
     144,   184,   185,   186,   187,    13,    15,    16,    17,    18,
      19,    20,    27,    28,    30,    32,   120,   126,   181,   182,
     216,   217,   233,   236,   241,   395,   402,   546,   559,   564,
     567,   568,   569,   571,   573,    36,    45,   398,   516,   527,
      19,    19,    20,    44,    55,   417,   421,    68,   143,   149,
      43,    62,   118,   179,   426,   427,    50,    67,    81,    19,
     117,    19,    86,   155,   143,   417,   573,    19,    19,   138,
     456,   456,   398,    73,    78,   122,   155,   244,   312,   369,
     374,   389,   456,    46,    66,    86,   116,   120,   121,   123,
     124,   125,   130,   160,   165,   399,   457,   475,   456,   456,
      51,    66,    80,   122,   123,   134,   137,   139,   179,   181,
     190,   226,   244,   251,   252,   254,   256,   257,   259,   260,
     262,   265,   266,   267,   280,   281,   285,   287,   288,   290,
     295,   299,   300,   302,   303,   305,   306,   307,   311,   399,
     457,   456,    84,   313,   318,   319,   320,   354,   361,   399,
     457,   600,   601,   602,   456,   370,   371,   399,   457,   456,
     456,    66,   179,   299,   399,   457,   657,   660,    73,    74,
      75,    77,    78,    80,    84,    87,   399,   440,   443,   457,
      75,   145,   399,   442,   457,    36,    45,   398,   476,   436,
       3,     3,   436,    67,   437,     3,     3,   527,   527,     3,
      36,    45,   398,   479,    86,   502,    19,    20,    45,   528,
       3,   178,   498,     3,     3,   495,   501,   255,    19,   123,
     186,   353,   367,   368,   491,   144,   186,   491,    18,    19,
     411,   413,   413,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   395,   401,   563,   565,   571,    30,
     395,   242,    28,   242,    15,   401,   566,   573,   395,   395,
     395,   395,   395,   395,   218,   219,   220,   221,   553,   573,
      15,    16,    17,    19,   395,   546,   547,   551,   554,   555,
     557,   559,   560,   561,     5,    82,    83,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   138,   169,   222,   223,   225,
     226,   227,   228,   229,   230,   231,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   297,   298,   314,   315,   316,
     317,   387,   388,   572,   670,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      33,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     423,   424,    15,   517,     3,    22,    63,   420,    45,   398,
     422,    15,    19,    35,    36,    37,    38,    69,   395,   408,
     410,   476,   408,    20,    58,    59,   394,   408,   409,   409,
     172,   161,   450,    15,    17,    18,    19,   138,   395,   445,
     530,    19,   447,   479,   394,   542,   138,    19,   398,   398,
     453,   398,   476,   309,    19,   461,   117,   408,   410,   474,
      45,    69,   126,   127,   135,   243,   458,   538,    69,   458,
      69,   417,   479,   394,   394,   398,   398,   172,   269,   309,
      81,   394,    20,   270,   417,   410,    69,    85,   179,   284,
     310,   158,   410,   394,   408,   411,   596,   175,   411,    76,
     258,   268,    76,   256,   263,   272,   273,    87,   268,   282,
     283,   282,   286,   410,   289,   291,   296,    86,    87,   122,
     301,    87,   304,   302,   410,   254,   410,   394,   398,   352,
     445,   410,   116,   408,   410,   117,   394,   398,   398,    86,
     372,   373,   394,   398,   398,   309,   413,    86,   394,   197,
     261,   292,   301,   390,   391,   392,   393,   398,   663,    86,
     410,    76,   410,    79,    81,    85,   408,   394,   394,   394,
      76,    20,   418,   394,   394,    79,   128,   129,   141,   142,
     144,   477,   478,     3,   437,     3,   408,     3,     3,     3,
     128,   166,   480,   481,     3,    19,     3,   528,     3,     3,
       3,    86,   148,   163,   175,   499,     3,    45,    86,   118,
     125,   126,   136,   145,   146,   147,   148,   150,   151,   413,
     496,   538,     3,    19,    86,   118,   119,   126,   153,   191,
     491,   491,   491,   639,    45,   491,    45,   491,     3,   491,
     491,     3,    30,   397,   415,   173,   173,     7,   565,   565,
     573,   565,   565,    14,    15,   573,   577,   578,    27,   242,
      28,   566,   566,    30,   573,   573,   573,   573,   573,    19,
      15,   400,   396,   400,    29,   549,   550,   553,   573,     7,
     400,   403,    27,    28,   398,   400,   403,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   201,   224,   232,   237,   238,   239,   399,   400,     3,
     573,   417,   423,   394,   409,   573,   408,    60,    61,    60,
      61,    39,    40,    41,   408,   469,   470,   573,   394,   199,
     200,   201,   202,   203,   204,   205,   207,   208,   209,   210,
     211,   532,   533,   534,   536,   540,    42,   156,   157,   158,
     394,   448,   394,   395,   539,    19,   153,   399,   410,   445,
     463,   466,   467,    36,   408,   460,    19,   536,   537,   136,
     573,   460,   460,   582,    76,    76,   410,    76,   308,   410,
     394,    51,   394,   394,   408,   247,   248,   410,   294,   410,
     166,   411,   394,   394,    31,   412,    42,   175,   394,   408,
     175,   408,    76,    76,   408,    76,   135,   264,   408,   408,
     410,    76,   394,   117,   394,   410,   394,   410,   264,   292,
     293,   410,   461,   410,   394,   394,   410,   410,   410,   394,
     175,   394,   410,   410,    69,   408,   603,    19,   394,   394,
     644,   410,   461,    20,   411,   411,   261,   658,   659,   662,
     394,   408,   408,   410,   410,   410,   408,   411,   413,   414,
     399,   400,     3,   399,   400,     3,    19,    15,   413,    19,
      19,   537,   414,    19,     3,    20,   630,   630,     3,    19,
     116,   264,   309,   313,   328,   359,   360,   491,   630,   491,
     630,   630,   630,   408,   411,    15,    15,    15,   396,   400,
     396,    28,   400,   400,   400,   396,   400,   396,   400,   573,
     573,     7,   400,   400,   396,    18,   395,   547,   555,    15,
      18,   560,   395,   424,   394,   399,   396,    20,   394,   467,
     394,   396,    19,   206,   394,   398,   408,   411,   396,   533,
     535,   540,   413,   394,    28,   465,   400,   131,   459,   410,
     123,   251,   252,   399,   457,   581,   408,   408,   394,   408,
     394,   394,   410,   394,   394,   394,   394,   410,   394,   410,
     394,    19,   596,   408,   408,   394,   408,   394,   408,   408,
     394,   408,   394,   394,   394,   394,   394,   408,   445,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   394,   394,
     394,   408,   408,   123,   178,   265,   319,   343,   345,   350,
     352,   356,   357,   399,   604,   611,   614,   394,   123,   354,
     375,   399,   457,   643,   394,   394,   412,   411,   244,   355,
     658,    19,    51,   120,   192,   193,   194,   195,   196,   197,
     198,   212,   215,   244,   399,   569,   570,   574,   579,   661,
      69,   439,   478,   481,     3,     3,   445,   445,    15,   445,
     630,     3,   630,     3,     3,     3,   175,   175,   565,   577,
      28,   573,   573,   573,   573,   573,   400,   396,   549,   573,
     550,   552,   573,   573,   400,   573,   534,   543,   544,   579,
     394,   396,   173,    20,   414,   464,   466,    81,   132,   133,
     134,   584,   588,   584,   589,   411,   593,   394,   400,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   394,   394,
     394,   394,   623,   629,   410,   321,   322,   356,   321,   410,
     605,   309,   413,   607,   608,   606,   358,   410,   394,   361,
     624,   646,   652,   410,   408,   394,   412,   410,   408,    22,
     395,    22,   395,   573,   573,   573,   410,   572,   670,   394,
     573,   575,   576,   408,     3,     3,    15,    15,   396,   396,
     396,   396,   400,   573,   396,   400,    15,   396,   399,   579,
     535,    15,   414,   467,   468,   398,   587,    31,   253,   590,
     408,   467,   625,   408,   408,   410,   408,   398,   445,   398,
     398,   408,   408,   398,   468,    69,   573,   578,   573,   569,
     394,   213,   398,   394,    22,    22,    33,   400,   394,   502,
     502,   573,   396,     7,    29,   552,   399,   175,   587,   586,
      19,   417,   254,   591,   394,   626,   398,   628,   616,   609,
     616,   612,   398,   651,   408,   394,   396,   394,   670,   398,
     545,   579,   562,   573,   573,   126,   181,   182,   236,   242,
     576,     3,     3,   396,   395,   396,     7,   396,    15,   139,
     245,   246,   249,   250,   399,   585,   411,   251,   592,   624,
     627,   399,   413,   617,   618,   178,   321,   344,   399,   610,
     399,   137,   159,   172,   323,   324,   325,   327,   338,   399,
     482,   484,   485,   613,   650,   647,   396,   543,   214,     6,
      15,    16,    17,   395,   399,   546,   548,   551,   554,   556,
     558,   394,   394,   395,   395,   395,   395,   394,   549,   552,
     394,   410,   247,   248,   248,   409,   408,   394,   410,    66,
     172,   186,   244,   247,   248,   303,   306,   309,   319,   321,
     323,   324,   325,   326,   327,   328,   334,   338,   339,   342,
     354,   362,   399,   482,   615,   344,   351,   619,   410,   408,
     410,   394,   417,   398,   408,   408,   408,   268,   147,   408,
     127,   337,   340,   398,   394,    42,    66,    67,    87,   139,
     158,   244,   247,   248,   303,   338,   354,   371,   376,   377,
     379,   380,   382,   399,   482,   648,   394,   399,   545,   543,
     573,     7,   397,   400,   573,   573,   573,   573,   400,   396,
     249,   249,   249,   309,   408,   398,   410,   347,   170,   171,
     326,   364,   471,   304,   410,   365,   410,   408,   408,   408,
     268,   408,   147,   408,   329,   330,   331,   332,   333,   334,
     335,   336,   363,   127,   337,   340,   331,   408,   355,   329,
     394,   408,   394,   483,   484,   408,   408,   117,   152,   196,
     486,   408,   309,   384,    76,   408,   410,   411,   410,   347,
     326,   364,   471,   304,   127,   340,   385,   386,   649,   355,
     329,   378,    76,    76,   346,   408,   381,   383,   394,   396,
     395,   548,   543,   556,   396,   396,   396,   396,   549,   409,
     409,   409,   410,   620,   348,   349,   408,   408,   408,   408,
     408,   248,   410,   366,   408,   408,   410,   410,   408,   410,
     399,   394,   408,   138,   140,   138,   140,   399,   410,   410,
     408,   408,   408,   408,   248,   410,   408,   408,   408,   410,
     410,   410,   573,   394,   394,   394,   394,   396,   399,   411,
     622,   346,   410,   483,   394,    20,   416,   416,   416,   416,
     346,   341,   621,   486,   394,   394,   394,   394,   394,   486,
     486,   486,   486
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   404,   405,   405,   406,   406,   407,   408,   408,   408,
     409,   409,   409,   410,   410,   410,   410,   410,   410,   411,
     411,   412,   412,   413,   414,   414,   415,   415,   416,   417,
     417,   418,   418,   419,   420,   420,   421,   421,   421,   422,
     422,   423,   423,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   425,   425,   426,   426,   426,   426,   427,   427,
     427,   427,   427,   427,   428,   429,   429,   429,   429,   430,
     431,   432,   433,   434,   435,   436,   436,   437,   437,   437,
     438,   439,   439,   440,   440,   440,   440,   440,   440,   441,
     442,   442,   443,   443,   444,   444,   445,   445,   445,   445,
     445,   446,   447,   447,   448,   448,   448,   448,   449,   450,
     450,   451,   452,   453,   453,   454,   454,   455,   455,   456,
     456,   456,   456,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   458,   458,   458,
     458,   459,   459,   459,   459,   459,   460,   460,   461,   462,
     462,   463,   464,   464,   464,   465,   465,   466,   467,   467,
     468,   469,   470,   471,   471,   472,   473,   473,   473,   473,
     474,   475,   476,   476,   476,   477,   477,   478,   478,   478,
     478,   478,   478,   479,   479,   479,   480,   480,   481,   481,
     482,   482,   483,   483,   484,   484,   485,   486,   486,   486,
     486,   486,   486,   487,   488,   489,   490,   491,   491,   492,
     493,   494,   495,   495,   495,   495,   495,   495,   495,   495,
     495,   495,   495,   495,   495,   496,   496,   496,   497,   498,
     498,   498,   498,   499,   499,   499,   500,   501,   501,   501,
     501,   501,   501,   501,   501,   502,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   516,   516,   517,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   527,   527,   528,   528,   528,
     530,   529,   531,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   533,   534,   534,   535,
     535,   536,   537,   537,   538,   539,   539,   540,   542,   541,
     543,   543,   544,   544,   545,   545,   546,   547,   547,   547,
     547,   547,   547,   548,   548,   548,   548,   548,   549,   550,
     550,   550,   551,   551,   552,   553,   553,   553,   553,   554,
     554,   554,   555,   555,   555,   555,   556,   556,   556,   556,
     557,   557,   558,   558,   559,   560,   560,   560,   560,   561,
     561,   562,   562,   562,   563,   563,   564,   564,   565,   565,
     565,   565,   565,   565,   566,   566,   566,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   568,   568,
     569,   570,   571,   572,   572,   572,   572,   572,   572,   572,
     572,   572,   572,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   574,   574,   574,   574,   574,   574,   575,   576,
     576,   576,   577,   577,   578,   578,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   580,   581,   581,   581,   581,   582,   582,   583,
     584,   585,   585,   585,   585,   585,   585,   586,   586,   587,
     587,   588,   589,   590,   590,   590,   591,   591,   592,   592,
     593,   594,   595,   596,   596,   596,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   598,   599,   599,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   601,   602,
     603,   603,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   605,   604,   606,   604,   604,   604,   604,   607,   607,
     608,   609,   609,   610,   610,   610,   611,   611,   612,   612,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   614,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   616,   616,   617,   618,   619,   619,   619,   620,   620,
     621,   621,   622,   623,   624,   624,   626,   625,   627,   627,
     628,   628,   629,   630,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   640,   641,   641,   641,   641,   641,   642,   643,
     643,   643,   643,   643,   644,   644,   645,   646,   647,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   648,   648,   649,   649,   649,   649,   650,   650,
     651,   651,   652,   653,   654,   655,   656,   656,   656,   656,
     656,   657,   658,   658,   658,   659,   659,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   661,   661,   662,   662,
     663,   663,   664,   665,   665,   665,   665,   665,   665,   665,
     665,   665,   665,   665,   665,   665,   665,   665,   665,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   668,   668,   668,
     668,   669,   669,   669,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     0,     2,     2,     3,     2,     3,     3,     4,     2,
       3,     3,     3,     2,     4,     5,     1,     3,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     1,     5,     0,
       1,     3,     3,     0,     8,     1,     4,     1,     1,     0,
       1,     2,     3,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     4,     2,     3,     2,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       1,     0,     2,     2,     2,     2,     3,     3,     3,     5,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     2,     2,     2,
       2,     3,     3,     2,     2,     1,     1,     1,     4,     0,
       3,     3,     3,     0,     1,     1,     4,     0,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     9,     9,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     1,     3,     0,     1,     3,     3,     3,     3,     4,
       4,     4,     4,     2,     1,     1,     1,     1,     0,     1,
       0,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     0,     3,     1,
       3,     1,     1,     1,     2,     3,     2,     4,     0,     5,
       0,     1,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     5,    11,     1,     1,     1,     2,     1,     7,
       9,     7,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     3,     1,     3,     3,     1,     2,     2,     6,     1,
       3,     0,     4,     3,     1,     3,     3,     3,     2,     4,
       2,     2,     2,     0,     2,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     5,     7,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     3,     5,     6,     6,     6,     6,     4,
       8,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     3,     1,     3,     0,     1,     4,     6,     4,     3,
       5,     5,     4,     6,     3,     2,     5,     5,     8,     8,
       8,     8,     2,     1,     2,     2,     2,     0,     3,     5,
       0,     2,     4,     4,     4,     2,     2,     0,     3,     0,
       3,     3,     2,     0,     2,     2,     0,     2,     0,     2,
       4,     5,     2,     0,     3,     3,     3,     3,     5,     6,
       4,     6,     4,     6,     4,     4,     5,     6,     3,     3,
       4,     5,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     5,     6,     4,     5,     4,     4,
       5,     4,     5,     4,     5,     5,     5,     5,     6,     5,
       5,     6,     5,     5,     5,     4,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     7,
       6,     7,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     5,     4,     4,     2,     1,
       2,     4,     2,     2,     0,     3,     5,     0,     0,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     4,     6,     6,     2,     3,     3,     5,     5,
       4,     2,     3,     3,     3,     1,     2,     4,     3,     3,
       3,     2,     2,     2,     2,     2,     1,     3,     0,     2,
       0,     3,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     1,     2,     2,     2,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 733 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 734 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 747 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 758 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 765 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 766 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 767 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 775 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 776 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 777 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 779 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 780 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 787 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 794 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 795 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 799 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 811 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 815 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 822 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 831 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 839 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 845 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 881 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 882 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 894 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 904 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 905 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 906 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 907 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 910 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 911 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 913 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 914 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 925 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 926 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 927 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 940 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 947 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 950 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 953 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 956 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 965 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 966 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 974 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 984 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 989 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 996 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 997 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 998 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1010 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1015 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1019 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1033 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1034 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1048 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1049 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1056 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1063 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1085 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1086 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1088 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1093 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1099 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1100 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1104 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1112 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1137 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1143 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1156 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1167 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1171 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1172 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1174 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1175 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1176 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1177 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1178 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1179 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1180 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1181 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1182 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1186 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1188 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1194 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1195 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1201 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1207 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1211 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1219 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1220 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1228 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1236 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1237 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1238 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1242 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1243 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1257 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1259 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1278 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1288 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 4804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1313 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1317 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1318 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1319 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1320 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1322 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1329 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1330 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1339 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1340 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1361 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1379 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1380 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1381 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1382 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1383 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1384 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1393 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1396 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1399 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1410 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1413 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1417 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1420 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1425 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1438 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1443 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1448 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1453 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1457 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1461 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1465 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1474 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1486 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1501 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1504 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1511 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1518 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1530 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1531 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1532 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1538 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1541 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1544 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1545 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1546 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1547 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1548 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1549 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1555 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1560 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1569 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1591 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1593 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1595 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1597 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1599 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1601 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1603 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1608 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1611 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1617 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1618 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1619 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1623 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1631 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1641 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1645 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1649 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1652 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1655 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1656 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1657 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1661 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1662 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1663 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1681 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1685 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1686 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5558 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1687 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1688 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1689 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5576 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1690 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1691 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5588 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1692 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1693 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1695 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1696 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1697 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1718 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1730 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1737 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1738 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5684 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1745 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1754 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1762 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1786 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1787 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1791 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1804 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1820 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1821 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1824 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1829 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1832 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1857 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1858 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 5856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1862 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 5866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1872 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1881 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1882 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1887 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1890 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1904 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1905 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1909 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1910 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1911 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1917 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1918 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1930 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1948 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1949 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1956 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1957 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1960 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1961 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1968 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1981 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2007 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2013 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2015 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2074 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2075 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2076 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2085 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2087 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2088 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2089 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2090 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2091 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2093 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2094 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2095 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2096 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2097 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2098 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','~');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2099 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2100 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6515 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6527 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2128 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2129 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2130 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2131 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2136 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2141 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2164 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2165 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2166 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2169 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2173 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2186 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2202 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2207 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2223 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2238 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2243 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2255 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2261 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2282 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2320 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2321 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2322 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2323 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2324 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2325 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2339 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2346 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2347 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2348 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2352 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2353 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2357 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2381 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2386 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
#line 7032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2420 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2421 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2423 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2429 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2430 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2431 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2432 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2433 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2434 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2435 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2436 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2437 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2438 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2439 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2440 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2441 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2442 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2443 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2444 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2446 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2451 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2452 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2453 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2454 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2456 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2458 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2460 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2461 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2462 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2464 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2465 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2466 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2473 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2474 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7318 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2475 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2476 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2477 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2479 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2480 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2481 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2482 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2483 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7378 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2485 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7384 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7390 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2487 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7396 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2514 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2515 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2516 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 7426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2518 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2519 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2524 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2539 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2548 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2549 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2550 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2551 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2552 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 7510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2555 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2557 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2558 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2590 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2591 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2602 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2603 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2604 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2605 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2606 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 7623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2607 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2608 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 7662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2643 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2645 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2646 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2647 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 7758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2648 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 7764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2649 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 7806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 7812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2658 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2661 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2665 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2667 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2668 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2681 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2701 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2706 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2715 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2738 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 7972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2756 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2761 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2767 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2770 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2773 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2781 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2786 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2789 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2793 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2800 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2801 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2802 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2821 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2826 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2834 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2847 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2848 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2849 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2863 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    {
  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2902 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2903 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2904 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2905 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2906 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2908 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2912 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2913 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 8254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2914 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 8260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2915 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 8266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2916 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 8272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 8278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2918 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 8284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2920 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 8296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2921 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 8302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 8308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2923 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 8314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2924 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 8320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2925 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 8326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 8332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 8344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 8350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 8356 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 8362 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2936 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2957 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 2960 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2966 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 2975 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 2976 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 2977 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 8413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 2980 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 8425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 2990 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 8439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 2999 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 8448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3003 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 8456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3009 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 8462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3010 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 8468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3014 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 8478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3019 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 8489 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3025 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 8497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3028 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3033 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3034 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3035 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3036 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3037 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3041 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 8542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3042 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3057 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 8554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3065 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 8560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3065 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 8566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 8596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 8602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 8608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 8614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 8620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 8626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 8632 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 8638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 8644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 8650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 8656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 8662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 8668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 8674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 8680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 8686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 8692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 8698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 8704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 8710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 8716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 8722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 8728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 8734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 8740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 8746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3070 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3074 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3075 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3076 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8864 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3082 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

